#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include "rpctypes.h"
#include "database.h"
#include "errors.h"
#include "archive.h"
 
#define ccerr(i) { cc = i; goto err; }
extern FEC *fec;
#define DATABLOB_SIZE 16384
BYTE g_datablob[DATABLOB_SIZE];
#define TRACE_BUFFER_SIZE DATABLOB_SIZE
BYTE *traceDataBuffer = g_datablob;
int totalNrFECs;
int nadbfiles = 0;
#define MAX_ADBFILES 20
char adbfile[MAX_ADBFILES][32];
#define cctxt(txt) { printf("HDA: %s\n>",txt); ccerr(database_not_loaded); }
#define quit(i) { printf("HDA: %s\n>",erlst[i]); exit(1); }
int archdebug = 0;
int archPending = 0;
int outputlen = 5;
time_t startuptime;
int bailout = 0;
int g_isTerminating;
int AppendProblemsLog(char *s) { return 0;}

FEC *fec;
 
#define addNumberFecs(f) {\
  sprintf(fn,"%s%s",ArchiveDBpath,f);\
  if ((fp = fopen(fn,"rt")) == NULL) return;\
  totalNrFECs += getNumLines(fp);\
  fclose(fp); }

int addADBtoList(char *fn)
{
  int i;
 
  for (i=0; i<nadbfiles && strncmp(adbfile[i],fn,16); i++);
  if (i < nadbfiles) return 0;
  if (nadbfiles == MAX_ADBFILES) return out_of_local_memory;
  strncpy(adbfile[i],fn,16);
  nadbfiles++;
  return 0;
}

int initScanner(void)
{
  int id,i,n,np,off=0,cc=0;
  static char fn[80],desc[256];
  char *c;
  FILE *fp;
 
  totalNrFECs = 0;
  for (i=0; i<nadbfiles; i++)
  {
    addNumberFecs(adbfile[i]);
  }
 
  if ((fec=calloc(totalNrFECs,sizeof(FEC))) == NULL) ccerr(out_of_server_memory);
if ((subSystems=(SUB_SYS *)calloc(totalNrFECs,sizeof(SUB_SYS))) == NULL) ccerr(out_of_server_memory);
if ((prpAlias=(PRP_ALIAS *)calloc(totalNrFECs,sizeof(PRP_ALIAS))) == NULL) ccerr(out_of_server_memory);
 
  for (i=0; i<nadbfiles; i++)
  {
    if (!(n=archLoad(adbfile[i],off))) cctxt("No Servers loaded!");
    if (!(np=paramLoad(n,off))) cctxt("No Parameters loaded!");
    off += n;
  }
err:if (cc)
  {
    printf("error: %s\n>",erlst[cc]);
    if (fec != NULL) free(fec);
    exit(1);
  }
  return;
}
#define getDataFilename(i,yy,mm) \
    sprintf(fec[i].fname,"he%02d%02d01.%0x",yy,mm,fec[i].rectyp)
 
char *months[] = {"Jan","Feb","Mar","Apr","May","Jun",
                  "Jul","Aug","Sep","Oct","Nov","Dec"};
int getmonth(char *m)
{
  int i;
  for (i=0; i<12; i++) if (!stricmp(m,months[i])) return i+1;
  return 0;
}
 
int getEntryFromRectyp(int rectyp)
{
  int i;
 
  for (i=0; i<totalNrFECs; i++)
    if (fec[i].rectyp == rectyp) return i;
  return -1;
}
int scan(int n)
{
  int hFile;
  long timebin,pstart,number = 0, cnt = 0;
  char s[80],c;
  BYTE data[512];
  DTYPE d;
  unsigned char dummy;
  int fmtsize,i,p;
  time_t timestamp,monthtime,starttime=time(NULL);
  struct tm *lt;
  FILE *fpout=NULL;

  lt = localtime((time_t *)&starttime);
 
  getDataFilename(n,lt->tm_year,lt->tm_mon+1);
  sprintf(s,"%s-fix",fec[n].fname);
  if ((fpout=fopen(s,"w")) == NULL) 
  {
    printf("can't open %s for writing\n",s);
    exit(1);
  }
 
  if ((hFile=OpenDataFile(n)) == -1) goto err;
  number = 0; cnt = 0;
  lseek(hFile,0,SEEK_SET);
 
  lt->tm_mday = 1; lt->tm_min = 0; lt->tm_sec = 0;
  monthtime = mktime(lt) - 3600*24;
  d.dFormat = fec[n].fmt;
  d.dArrayLength = 1;
  while(read(hFile,&timestamp,4) == 4)   // read through file
  {
check_timestamp:
    if (timestamp < monthtime || timestamp > starttime)
    {
      printf("read timestamp %d : %s\n",timestamp,ctime(&timestamp));
      if (bailout) exit(1);
//      printf("should I try to repair it? : "); c = getchar(); getchar(); 
//      if (c == 'y')
//      {
        read(hFile,&dummy,1);
        read(hFile,&timestamp,4);
//        read(hFile,traceDataBuffer,fec[n].reclen);
        printf("corrected timestamp : %d : %s\n",timestamp,ctime(&timestamp));
        goto check_timestamp;
 //     }
 //     else if (c == 'x') exit(1);
    }
    if (fwrite(&timestamp,4,1,fpout) != 1)
    {
      printf("can't write timestamp to %s\n",s);
      exit(1);
    }
    printf("time : %s\n",ctime(&timestamp));
    if (read(hFile,traceDataBuffer,fec[n].reclen) != fec[n].reclen) goto err;
    if (fwrite(traceDataBuffer,fec[n].reclen,1,fpout) != 1)
    {
      printf("can't write record to %s\n",s);
      exit(1);
    }
    for (i=0; i<fec[n].nparam; i++)
    {
      printf("param : %s\n", fec[n].fecdata[i].param);
      d.data.vptr = traceDataBuffer + fec[n].fecdata[i].offset;
      for (p=0; p<fec[n].fecdata[i].size && p<outputlen; p++)
      {
        switch (fec[n].fecdata[i].format)
        {
          case CF_LONG: 
            printf("%d ",d.data.lptr[p]);
            break;
          case CF_FLOAT:
            printf("%g ",d.data.fptr[p]);
            break;
          case CF_DOUBLE:
            printf("%g ",d.data.dptr[p]);
            break;
          case CF_NAME16:
            printf("%16s ",&d.data.cptr[p*16]);
            break;
          case CF_NAME32:
            printf("%32s ",&d.data.cptr[p*32]);
            break;
          case CF_NAME48:
            printf("%c ",&d.data.cptr[p*48]);
            break;
          default: 
            printf("format %d unexpected\n",fec[n].fecdata[i].format);
            goto err;
        }
      }
      printf("\n");
    }
  }
err: if (hFile != -1) close(hFile);
  fclose(fpout); 
  return number;
}

int main(int argc, char *argv[])
{
  int i,cc,rn;
  char *c,fn[64];
  switch (argc)
  {
    case 5:
      bailout = atoi(argv[4]);
    case 4:   
      outputlen = atoi(argv[3]);
    case 3:   
      rn = atoi(argv[2]);
      strncpy(fn,argv[1],64);
      break;
    default:
     printf("usage: dbscan <dbase> <recno> <output length>\n");
     printf("   eg: dbscan datapktr.csv 15 5\n");
     exit(1); 
  }
  startuptime = time(NULL);
  addADBtoList(fn); 
  initScanner();

  for (i=0; i<totalNrFECs; i++)
  {
     if (fec[i].rectyp == rn) break;
  }
  if (i == totalNrFECs)
  {
    printf("record %d not found in database\n",rn);
    exit(2);
  }
  printf("scanning record %s\n",fec[i].property);
  if ((c=getchar()) == 'x') exit(0);

  scan(i);

  return 0;
}
