/*
 * CASEQM.c    REVISION HISTORY:
 * Generated by SRVWIZARD on Fri Jan 26 18:01:41 2001
*/

#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "errors.h"
#include "rpctypes.h"
#include "servdef.h"
#include "database.h"
#include "swaplib.h"
#include "almsrv.h"
#include "toolkit.h"
#include "arctools.h"
#include "caseqm.h"
#include "lpceqm.h"
#if defined(WINNT)
# include "ntcmd.h"
#elif defined(UNIX)
# include "unixcmd.h"
#endif

#define almDISABLED 0x20
char casExportName[16];
char AlarmArchivePath[80] = DEFAULT_ARCHIVE_PATH;
AMS g_sysalarmsBuffer[PRP_SYSALARMS_SIZE];
short g_numalarms;
CAS_LIST *CASList = NULL;
int nCASList = 0;
int debug = 0;
time_t g_AckThreshold = 0;
char *casListFile = CAS_LIST_FILE;
extern int g_isTerminating;
int logproblem(char *text,...);

/* =======================================================================

   An archived file contains the following information according the
	 following protocol:

       DeviceServerName - 16 bytes   char string
       Property         - 32 bytes   char string
       DeviceName       - 16 bytes   char string
       size of call     - 2  bytes   short
       data format      - 2  bytes   short
       scale            - 4  bytes   float
       shift            - 4  bytes   float
       data buffer - N bytes according to format and size

  The above is repeated N times ....

  ========================================================================  */

FILE *createAndOpen(char *fname);
int isDuplicatedAlarm(AMS *ams, CAMS *pcams);
void AppendGeneratedAlarm(int i,int almsys,int almsev,int almdsc);
void AcquireAlarmInfo(int i);
int GetARBIndex(char *srvName) { return -1; } /* cover function */
int CASPrepOutgoingXAMS(CAS_LIST *clst,AMS *src,XAMS *dst,int siz);
int getAlarmSystemNumberFromTag(char *tag);
#define quit(i) { printf("Register struct: out of memory\n"); exit(i); }
int RecordEvent(ulong eventNumber,ulong eventCode,char *devName)
{
  return 0;
}
int SetGlobalEvent(ulong eventCode,char *name)
{
  return 0;
}
void registerStructs(void)
{
  if (fillstruct("CASQS",OFFSETIN(CASQS,devContext),16,CF_TEXT)) quit(1);
  if (fillstruct("CASQS",OFFSETIN(CASQS,devServer),16,CF_TEXT)) quit(1);
  if (fillstruct("CASQS",OFFSETIN(CASQS,subSystem),16,CF_TEXT)) quit(1);
  if (fillstruct("CASQS",OFFSETIN(CASQS,arcExt),16,CF_TEXT)) quit(1);
  if (fillstruct("CASQS",OFFSETIN(CASQS,SeverityLevel),1,CF_LONG)) quit(1);
  if (fillstruct("CASQS",OFFSETIN(CASQS,ArchiveLevel),1,CF_LONG)) quit(1);
  if (fillstruct("CASQS",OFFSETIN(CASQS,Retention),1,CF_LONG)) quit(1);
  if (fillstruct("CASQS",OFFSETIN(CASQS,AlarmLevel),1,CF_LONG)) quit(1);
  if (fillstruct("CASQS",OFFSETIN(CASQS,AlarmSystem),1,CF_LONG)) quit(1);
  if (fillstruct("CASQS",sizeof(CASQS),1000,CF_NULL)) quit(1);

  if (fillstruct("XAMS",OFFSETIN(XAMS,server),16,CF_TEXT)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,device),16,CF_TEXT)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,alarmText),40,CF_TEXT)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,alarmCode),1,CF_LONG)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,timestamp),1,CF_LONG)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,alarmMask),1,CF_LONG)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,alarmSystem),1,CF_LONG)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,alarmData),8,CF_BYTE)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,alarmDataFormat),1,CF_BYTE)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,alarmDataArraySize),1,CF_BYTE)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,severity),1,CF_BYTE)) quit(1);
  if (fillstruct("XAMS",OFFSETIN(XAMS,descriptor),1,CF_BYTE)) quit(1);
  if (fillstruct("XAMS",sizeof(XAMS),1000,CF_NULL)) quit(1);
}
int makecasname(char *fname,char *src,char *ext,time_t t)
{
  struct tm *ts;
  int yr, mo;
  FILE *fp = NULL;
  time_t ht = (t / 3600) * 3600;

  ts = localtime(&t);
  yr = ts->tm_year + 1900;
  mo = ts->tm_mon + 1;

  sprintf(fname,"%s/%d/%02d/%s/%lx.%s",src,yr,mo,ext,ht,ext);
  if ((fp=fopen(fname,"r")) == NULL) return 0;
  fclose(fp);
  strcat(fname,"-add");
  return -1;
}
void AppendAMS(char *filename)
{
  int n,num=0,cc=0;
  short sval;
  FILE *fp = NULL, *afp = NULL, *nfp = NULL;
  char *c,fname[128],nfname[128],buf[256],rbuf[256];

  strncpy(fname,filename,128);
  if ((c=strstr(fname,"-add")) == NULL) return;
  *c = 0;
  if ((fp=fopen(fname,"r")) == NULL) ccerr(file_error);
  if ((afp=fopen(filename,"r")) == NULL) ccerr(file_error);
  strncpy(nfname,fname,128); strcat(nfname,"-new");
  if ((nfp=fopen(nfname,"w")) == NULL) ccerr(file_error);
  if (fread(buf,80,1,fp) == 1)
  {
    memcpy(rbuf,buf,76);
    memcpy(&n,&buf[76],4);
    num += n;
  }
  if (fread(buf,80,1,afp) == 1)
  {
    memcpy(&n,&buf[76],4);
    num += n;
  }
  fwrite(rbuf,76,1,nfp);
  memcpy(buf,&num,4);
  fwrite(buf,4,1,nfp);
  if (fread(buf,76,1,fp) != 1) ccerr(file_error);
  fwrite(buf,64,1,nfp);
  sval = num*AMS_SIZE;
  memcpy(&buf[0],&sval,2);
  sval = CF_STRUCT;
  memcpy(&buf[2],&sval,2);
  fwrite(buf,4,1,nfp);
  fwrite(&buf[68],8,1,nfp);

  while (fread(buf,AMS_SIZE,1,fp) == 1)
  {
    fwrite(buf,AMS_SIZE,1,nfp);
  }
  if (fread(buf,76,1,afp) != 1) ccerr(file_error);
  while (fread(buf,AMS_SIZE,1,afp) == 1)
  {
    fwrite(buf,AMS_SIZE,1,nfp);
  }
  fclose(fp); fp = NULL; remove(fname);
  fclose(afp); afp = NULL; remove(filename);
  fclose(nfp); nfp = NULL;
  rename(nfname,fname);
  return;
err:
  feclog("AppendAMS: %s -> %s",filename, erlst[cc]);
  if (fp != NULL) fclose(fp);
  if (afp != NULL) fclose(afp);
  if (nfp != NULL) fclose(nfp);
}
void ArchiveAMS(int nalms, AMS *ams,char *devsvr, char *ext,UINT32 stoptime)
{
  char fn[128],str[128];
  FILE *fp=NULL;
  int ival,cc=0,found=0;
  short sval;
  float fval;
  char s[80];

  if (g_isTerminating || debug) feclog("archive alarms for %s",devsvr);

  if (stoptime < 100) 
  { /* invalid timestamp !! */
    feclog("attempted to archive %s with invalid timestamp %d",devsvr,stoptime);
    return;
  }
  /* use EVENT archive structure for nalms and then the AMS list */
  found = makecasname(fn,AlarmArchivePath,ext,stoptime);
  if ((fp=fopen(fn,"w")) == NULL &&
      (fp=createAndOpen(fn)) == NULL) ccerr(no_such_file);

  /* put number of alarms in archive: */
  strncpy(s,casExportName,16);
  if (fwrite(s,16,1,fp) != 1) ccerr(file_error);
  strncpy(s,"NUMALARMS",32);
  if (fwrite(s,32,1,fp) != 1) ccerr(file_error);
  memset(s,0,16);
  if (fwrite(s,16,1,fp) != 1) ccerr(file_error);
  sval = 1; memcpy(&s[0],&sval,2);
  sval = CF_LONG; memcpy(&s[2],&sval,2);
  if (fwrite(s,4,1,fp) != 1) ccerr(file_error);
  fval = 1.0; memcpy(&s[0],&fval,4);
  fval = 0.0; memcpy(&s[4],&fval,4);
  if (fwrite(s,8,1,fp) != 1) ccerr(file_error);
  ival = nalms; memcpy(&s[0],&ival,4);
  if (fwrite(s,4,1,fp) != 1) ccerr(file_error);
  /* now put the alarms in archive */
  strncpy(s,casExportName,16);
  if (fwrite(s,16,1,fp) != 1) ccerr(file_error);
  strncpy(s,"SYSALARMS",32);
  if (fwrite(s,32,1,fp) != 1) ccerr(file_error);
  memset(s,0,16);
  if (fwrite(s,16,1,fp) != 1) ccerr(file_error);
  sval = nalms*AMS_SIZE; memcpy(&s[0],&sval,2);
  sval = CF_STRUCT; memcpy(&s[2],&sval,2);
  if (fwrite(s,4,1,fp) != 1) ccerr(file_error);
  fval = 1.0; memcpy(&s[0],&fval,4);
  fval = 0.0; memcpy(&s[4],&fval,4);
  if (fwrite(s,8,1,fp) != 1) ccerr(file_error);
  if (fwrite(ams,AMS_SIZE,nalms,fp) != (UINT32)nalms) ccerr(file_error);

err:
  if (fp) fclose(fp);
  if (cc != 0) 
  {
    sprintf(str,"Alarm Archive %s : %s",fn,erlst[cc]);
    feclog(str);
    if (debug) 
    {
      sprintf(dbgbuf,"%s\n",str);
      dbgoutput(dbgbuf,tnull);
    }
    found = 0;
  }
  if (found) AppendAMS(fn);
  return;
}
int RegisterCaseqmProperties(void)
{
  int cc = 0;

  if ((cc=RegisterPropertyEx(CASEQM_TAG,"SYSALARMS",PRP_SYSALARMS_SIZE,CF_STRUCT,CA_READ,"current system alarms",PRP_SYSALARMS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(CASEQM_TAG,"NUMALARMS",PRP_NUMALARMS_SIZE,CF_SHORT,CA_READ,"Nr of current alarms",PRP_NUMALARMS)) < 0) goto err;
  if ((cc=RegisterPropertyEx(CASEQM_TAG,"SERVERINFO",PRP_SERVERINFO_SIZE,CF_STRUCT,CA_READ,"Nr of current alarms",PRP_SERVERINFO)) < 0) goto err;
  if ((cc=RegisterPropertyEx(CASEQM_TAG,"ACKTIME",PRP_ACKTIME_SIZE,CF_LONG,CA_READ|CA_WRITE,"[0:1E11 sec]read/write alarm view threshold",PRP_ACKTIME)) < 0) goto err;
err:
  if (cc)
  {
    printf("Can't register property : %s\n>",erlst[-cc]);
  }
  return cc;
}

CAS_ACTION *getCASActionList(char *fn)
{
  FILE *fp = NULL;
  int cc=0,done=0;
  int con_col,srv_col,dev_col,prp_col,code_col,lvl_col;
  char contxt[17],devsrv[17],dev[17];
  char str[256],hdr[256],scratch[16];
  CAS_ACTION *ca,*caList = NULL;

  if ((fp=fopen(fn,"r")) == NULL) ccerr(no_such_file);
  while (fgets(str,255,fp) != NULL)
  {
    if (strlen(str) == 0) continue;          /* carriage return */
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      strncpy(hdr,str,255);
      con_col = findcol(hdr,"CONTEXT");
      if ((srv_col=findcol(hdr,"SERVER")) < 0) ccerr(no_such_column);
      if ((dev_col = findcol(hdr,"DEVICE")) < 0) ccerr(no_such_column);
      if ((prp_col = findcol(hdr,"PROPERTY")) < 0) ccerr(no_such_column);
      if ((code_col = findcol(hdr,"ALARMCODE")) < 0) ccerr(no_such_column);
      if ((lvl_col = findcol(hdr,"ACTIONLEVEL")) < 0) ccerr(no_such_column);
      done = 1;                              /* read header info */
      continue;
    }
    if ((ca=(CAS_ACTION *)calloc(1,sizeof(CAS_ACTION))) == NULL) ccerr(out_of_server_memory);
    strncpy(scratch,colptr(code_col,str),16);
    ca->alarmCode = atoi(scratch);
    if (con_col >= 0) 
    {
      strncpy(contxt,colptr(con_col,str),16); contxt[16] = '0'; 
      sprintf(ca->devName,"/%s/",contxt);
    }
    strncpy(devsrv,colptr(srv_col,str),16); devsrv[16] = 0;
    strcat(ca->devName,devsrv); strcat(ca->devName,"/");
    strncpy(dev,colptr(dev_col,str),16); dev[16] = 0;
    strcat(ca->devName,dev);
    strncpy(ca->devProperty,colptr(prp_col,str),32);
    strncpy(scratch,colptr(lvl_col,str),16);
    ca->actionLevel = atoi(scratch);
    ca->din.dArrayLength = 1;
    ca->din.dFormat = CF_LONG;
    ca->din.data.lptr = (UINT32 *)&ca->actionLevel;
    ca->dout.dArrayLength = 0;
    ca->dout.dFormat = CF_NULL;
    ca->access = CA_WRITE|CA_READ;
    ca->nxt = caList;
    caList = ca;
  }
err:
  if (fp) fclose(fp);
  if (cc == 0) 
  {
    sprintf(str,"CAS ACTION file %s : found",fn);
    feclog(str);
  }
  return caList;
}
int nAlarmSystems = 0;    /* Each Alarm has an alarm system number */
ALARMSYSTEM *AlarmSystems = NULL;
CSVCOLUMN csvAlarmSystem[] =
{
  { "NR","",0,CF_LONG,1,(BYTE *)OFFSETIN(ALARMSYSTEM,number),NULL, 0},
  { "TAG","",0,CF_TEXT,16,(BYTE *)OFFSETIN(ALARMSYSTEM,tag),NULL, 0},
  { "SUBSYSTEM","",0,CF_TEXT,16,(BYTE *)OFFSETIN(ALARMSYSTEM,subsystem),NULL, 0}
};
CSVDB csvAlarmSystemDb = 
{
  csvAlarmSystem,
  sizeof(csvAlarmSystem)/sizeof(csvAlarmSystem[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(ALARMSYSTEM)
};
int getAlarmSystemList(char *fn)
{
  int cc;
  if ((cc=csvReadFile(FecDBpath,fn,&csvAlarmSystemDb,(void **)&AlarmSystems)) != 0) ccerr(cc);
  nAlarmSystems = csvAlarmSystemDb.siz;
err:
  return cc;
}
extern CSVDB csvAlarmInfoDb;
int needToAcquireAlarmDefs = FALSE;
int csvCASAlarmInfoGetFormat(char *fmtstr);
CSVCOLUMN csvCASAlarmInfoColumns[] =
{
  { "ALARM_TAG","",0,CF_TEXT,16,(BYTE *)OFFSETIN(ADS,alarmTag),NULL,0 },
  { "ALARM_CODE","0",0,CF_LONG,1,(BYTE *)OFFSETIN(ADS,alarmCode),NULL,0 },
  { "ALARM_MASK","0",0,CF_LONG,1,(BYTE *)OFFSETIN(ADS,alarmMask),NULL,0 },
  { "SEVERITY","1",0,CF_SHORT,1,(BYTE *)OFFSETIN(ADS,severity),NULL,0 },
  { "DATA_FORMAT","",0,CF_NULL,1,NULL,csvCASAlarmInfoGetFormat,0 },
  { "DATA_ARRAYSIZE","0",0,CF_BYTE,1,(BYTE *)OFFSETIN(ADS,alarmDataArraySize),NULL,0 },
  { "TIME_RESOLUTION","0",0,CF_LONG,1,(BYTE *)OFFSETIN(ADS,timeRes),NULL,0 },
  { "HITS_CHANNEL","0",0,CF_SHORT,1,(BYTE *)OFFSETIN(ADS,hitsChannel),NULL,0 },
  { "HITS_MODULE","0",0,CF_SHORT,1,(BYTE *)OFFSETIN(ADS,hitsModule),NULL,0 },
  { "ALARM_TEXT","not supplied",0,CF_TEXT,40,(BYTE *)OFFSETIN(ADS,alarmText),NULL,0 },
  { "DEVICE_TEXT","not supplied",0,CF_TEXT,38,(BYTE *)OFFSETIN(ADS,deviceText),NULL,0 },
  { "DATA_TEXT","not supplied",0,CF_TEXT,40,(BYTE *)OFFSETIN(ADS,dataText),NULL,0 },
  { "URL","not supplied",0,CF_TEXT,40,(BYTE *)OFFSETIN(ADS,url),NULL,0 },
  { "ALARM_SYSTEM","0",0,CF_SHORT,1,(BYTE *)OFFSETIN(ADS,alarmSystem),NULL,0 }
};
CSVDB csvCASAlarmInfoDb =
{
  csvCASAlarmInfoColumns,
  sizeof(csvCASAlarmInfoColumns)/sizeof(csvCASAlarmInfoColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(ADS)
};
int csvCASAlarmInfoGetFormat(char *fmtstr)
{
  if (fmtstr == NULL) return 0;
  ((ADS *)csvCASAlarmInfoDb.tgt)[csvCASAlarmInfoDb.cnt].alarmDataFormat = BFMT(ftoi(fmtstr));
  return 0;
}
int writeAlarmDefinitionsToFile(CAS_LIST *cl)
{
  int i, cc=0;
  FILE *fp=NULL;
  char fn[128],str[512];

  sprintf(fn,"%s/AlarmInfo/%s/%s-alarms.csv",AlarmArchivePath,cl->arcExt,cl->devServer);
  if ((fp=fopen(fn,"w")) == NULL &&
      (fp=createAndOpen(fn)) == NULL) ccerr(no_such_file);
  strcpy(str,"ALARM_TAG,ALARM_CODE,ALARM_MASK");
  strcat(str,",SEVERITY,DATA_FORMAT,DATA_ARRAYSIZE");
  strcat(str,",TIME_RESOLUTION,HITS_CHANNEL,HITS_MODULE");
  strcat(str,",ALARM_TEXT,DEVICE_TEXT,DATA_TEXT,URL,ALARM_SYSTEM");
  fprintf(fp,"%s\n",str); /* header */
  for (i=0; i<cl->nAdsList; i++)
  {
    str[16] = 0;
    strncpy(str,((ADS *)cl->adsList)[i].alarmTag,16);
    sprintf(&str[strlen(str)],",%d",((ADS *)cl->adsList)[i].alarmCode);
    sprintf(&str[strlen(str)],",%d",((ADS *)cl->adsList)[i].alarmMask);
    sprintf(&str[strlen(str)],",%d",((ADS *)cl->adsList)[i].severity);
    sprintf(&str[strlen(str)],",%s",itof(((ADS *)cl->adsList)[i].alarmDataFormat));
    sprintf(&str[strlen(str)],",%d",((ADS *)cl->adsList)[i].alarmDataArraySize);
    sprintf(&str[strlen(str)],",%d",((ADS *)cl->adsList)[i].timeRes);
    sprintf(&str[strlen(str)],",%d",((ADS *)cl->adsList)[i].hitsChannel);
    sprintf(&str[strlen(str)],",%d",((ADS *)cl->adsList)[i].hitsModule);
    strcat(str,","); str[strlen(str)+40] = 0;
    strncpy(&str[strlen(str)],((ADS *)cl->adsList)[i].alarmText,40);
    strcat(str,","); str[strlen(str)+38] = 0;
    strncpy(&str[strlen(str)],((ADS *)cl->adsList)[i].deviceText,38);
    strcat(str,","); str[strlen(str)+40] = 0;
    strncpy(&str[strlen(str)],((ADS *)cl->adsList)[i].dataText,40);
    strcat(str,","); str[strlen(str)+40] = 0;
    strncpy(&str[strlen(str)],((ADS *)cl->adsList)[i].url,40);
    sprintf(&str[strlen(str)],",%d",((ADS *)cl->adsList)[i].alarmSystem);
    fprintf(fp,"%s\n",str);
  } 
err:
  if (fp != NULL) fclose(fp);
  return cc;
}
int getAlarmDefinitionsFromFile(CAS_LIST *cl)
{
  int cc=0;
  FILE *fp=NULL;
  char fn[128];
  static int done = 0;

  sprintf(fn,"%s/AlarmInfo/%s/%s-alarms.csv",AlarmArchivePath,cl->arcExt,cl->devServer);
  if ((fp=fopen(fn,"r")) == NULL) ccerr(no_such_file);
  csvReadFile(NULL,fn,&csvCASAlarmInfoDb,(void **)&cl->adsList);
  cl->nAdsList = csvCASAlarmInfoDb.siz;
  cl->adsListAcquired = TRUE;
err:
  return cc;
}
int getAlarmDefinitionsFromServer(CAS_LIST *cl)
{
  int cc=0,i;
  char devname[128];
  DTYPE dout;

  if (cl == NULL) ccerr(argument_list_error);
  sprintf(devname,"/%s/%s/#0",cl->devContext,cl->devServer);
  dout.dFormat = CF_SHORT;
  dout.dArrayLength = 1;
  dout.dTag[0] = 0;
  dout.data.sptr = (UINT16 *)&cl->nAdsList;
  cc = connection_timeout;
  for (i=0; i<2 && cc != 0; i++)
  {
    cc = ExecLinkEx(devname,"NALMDEFS",&dout,NULL,CA_READ,500);
  }
  if (cc != 0) ccerr(cc);
  if (cl->nAdsList == 0) ccerr(0);
  if ((cl->adsList=(ADS *)calloc(cl->nAdsList,sizeof(ADS))) == NULL)
    ccerr(out_of_server_memory);
  dout.dFormat = CF_STRUCT;
  dout.dArrayLength = cl->nAdsList;
  strcpy(dout.dTag,"ADS");
  dout.data.vptr = cl->adsList;
  cc = connection_timeout;
  for (i=0; i<2 && cc != 0; i++)
  {
    cc = ExecLinkEx(devname,"ALMDEFS",&dout,NULL,CA_READ,500);
  }
  if (cc) ccerr(cc);
  writeAlarmDefinitionsToFile(cl); 
err:
  if (cc == 0 && cl != NULL) cl->adsListAcquired = TRUE;
  return cc;
}
int getAlarmDefinitions(CAS_LIST *cl)
{
  int cc;
  if ((cc=getAlarmDefinitionsFromServer(cl)) != 0)
    cc = getAlarmDefinitionsFromFile(cl);
  return cc;
}

int getServerAlarmSystemList(CAS_LIST *cl)
{
  FILE *fp = NULL;
  int cc=0,done=0,i=0,n,nr;
  int sys_col=-1;
  char fn[64],str[256],hdr[256],scratch[16];

  if (cl == NULL || strlen(cl->devServer) == 0) ccerr(argument_list_error);
  sprintf(fn,"%s-alarmsystems.csv",cl->devServer);
  if ((n=GetDataBaseSize(fn)) < 0) ccerr(-n);
  if (n == 0) ccerr(file_error);
  if ((cl->almSystemList=(int *)calloc(n,sizeof(int))) == NULL) ccerr(out_of_server_memory);
  if ((fp=fopen(fn,"r")) == NULL) ccerr(no_such_file);
  while (fgets(str,255,fp) != NULL)
  {
    if (strlen(str) == 0) continue;          /* carriage return */
    if (strchr("%;#\n",str[0])) continue;    /* comment line(s) */
    if (!done)
    {
      strncpy(hdr,str,255);
      if ((sys_col=findcol(hdr,"SYSTEM")) < 0) ccerr(no_such_column);
      done = TRUE;                            /* read header info */
      continue;
    }
    strncpy(scratch,colptr(sys_col,str),16);
    nr = atoi(scratch);
    if (nr == 0) nr = getAlarmSystemNumberFromTag(scratch);
    cl->almSystemList[i] = nr;
    i++;
  }
  cl->nAlmSystemList = n;
err:
  if (fp) fclose(fp);
  return cc;
}
int nAlarmSubSystems = 0; /* Each FEC belongs to a sub-system */
NAME16 *AlarmSubSystems = NULL;
INTINT *AlarmSubRanges  = NULL;
int getCASList(char *fn)
{
  FILE *fp = NULL;
  int cc=0,done=0,i=0,n;
  int con_col,srv_col,sev_col,arc_col,ret_col,alm_col,trg_col,sub_col,sys_col,ext_col,off_col;
  char str[256],hdr[256],actfilename[80],scratch[16];

  if ((nCASList=GetDataBaseSize(fn)) < 0) ccerr(-nCASList);
  if (nCASList == 0) ccerr(file_error);
  if ((CASList=(CAS_LIST *)calloc(nCASList,sizeof(CAS_LIST))) == NULL) ccerr(out_of_server_memory);
  /* it won't be any worse than this: */
  if ((AlarmSubSystems=(NAME16 *)calloc(nCASList,sizeof(NAME16))) == NULL) ccerr(out_of_server_memory);
  if ((AlarmSubRanges=(INTINT *)calloc(nCASList,sizeof(INTINT))) == NULL) ccerr(out_of_server_memory);
  if ((fp=fopen(fn,"r")) == NULL) ccerr(no_such_file);
  while (fgets(str,255,fp) != NULL)
  {
    if (strlen(str) == 0) continue;          /* carriage return */
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      strncpy(hdr,str,255);
      con_col = findcol(hdr,"CONTEXT");
      if ((srv_col=findcol(hdr,"SERVER")) < 0) ccerr(no_such_column);
      sev_col = findcol(hdr,"SEVERITYLEVEL");
      arc_col = findcol(hdr,"ARCHIVELEVEL");
      ret_col = findcol(hdr,"RETENTION");
      alm_col = findcol(hdr,"ALARMLEVEL");
      trg_col = findcol(hdr,"TRIGGERFILE");
      sub_col = findcol(hdr,"SUBSYSTEM");
      sys_col = findcol(hdr,"ALARMSYSTEM");
      ext_col = findcol(hdr,"EXTENSION");
      off_col = findcol(hdr,"OFFLINE");
      done = 1;                              /* read header info */
      continue;
    }
    strncpy(CASList[i].devServer,colptr(srv_col,str),16);
    strncpy(CASList[i].devContext,con_col >= 0 ? colptr(con_col,str) : "DEFAULT",16);
    if (off_col >= 0)
    {
      strncpy(scratch,colptr(off_col,str),16);
      CASList[i].offline = atoi(scratch);
    }
    if (sev_col >= 0)
    {
      strncpy(scratch,colptr(sev_col,str),16);
      CASList[i].SeverityLevel = atoi(scratch);
    }
    if (arc_col >= 0)
    {
      strncpy(scratch,colptr(arc_col,str),16);
      CASList[i].ArchiveLevel = atoi(scratch);
    }
    if (ret_col >= 0)
    {
      strncpy(scratch,colptr(ret_col,str),16);
      CASList[i].Retention = atoi(scratch);
    }
    if (alm_col >= 0)
    {
      strncpy(scratch,colptr(alm_col,str),16);
      CASList[i].AlarmLevel = atoi(scratch);
    }
    if (trg_col >= 0)
    {
      strncpy(actfilename,colptr(trg_col,str),80);
      CASList[i].actionList = getCASActionList(actfilename);
    }
    if (sys_col >= 0)
    {
      strncpy(scratch,colptr(sys_col,str),16);
      CASList[i].AlarmSystem = atoi(scratch);
    }
    if (sub_col >= 0)
    {
      strncpy(CASList[i].subSystem,colptr(sub_col,str),16);
      for (n=0; n<nAlarmSubSystems; n++) if (!strncmp(CASList[i].subSystem,AlarmSubSystems[n].name,16)) break;
      if (n == nAlarmSubSystems)
      {
        strncpy(AlarmSubSystems[n].name,CASList[i].subSystem,16);
        nAlarmSubSystems++;
      }
      if (CASList[i].AlarmSystem <= (int)AlarmSubRanges[n].i1val || 
          AlarmSubRanges[n].i1val == 0)
        AlarmSubRanges[n].i1val = CASList[i].AlarmSystem;
      if (CASList[i].AlarmSystem >= (int)AlarmSubRanges[n].i2val)
        AlarmSubRanges[n].i2val = CASList[i].AlarmSystem;
    }
    else strncpy(CASList[i].subSystem,"TST",16);

    strncpy(CASList[i].arcExt,ext_col >= 0 ? colptr(ext_col,str) : "CAS",16);

    getServerAlarmSystemList(&CASList[i]);
    i++;
  }
err:
  if (fp) fclose(fp);
  sprintf(str,"CAS file %s : %s",fn,cc ? erlst[cc] : "found");
  feclog(str);
  return cc;
}
void TakeActionCallback(int id,int cc)
{
  CAS_ACTION *ca = (CAS_ACTION *)id;
  char str[256],tmp[64];
  int i;
  DTYPE din;

  if (cc)
  {
    sprintf(str,"Action %s %s: %s",ca->devName,ca->devProperty,erlst[cc]); feclog(str);
    if (ca->retry-- > 0)
    {
      sprintf(str,"retry %s %s\n",ca->devName,ca->devProperty); feclog(str);
      TakeAction(ca);
    }
  }
  else
  {
    if (!strcmp(ca->devProperty,"TRIGGER"))
    {
      /* prepare annotation */
      sprintf(str,"%s (generated by %s %s) : ",
        ca->ams->alarmTag,ca->ams->tag,ca->ams->device);
      for (i=0; i<ca->ams->alarmDataArraySize; i++)
      {
        switch (ca->ams->alarmDataFormat)
        {
          case CF_SHORT:
            sprintf(tmp,"%g ",((short *)ca->ams->alarmData)[i]);
            strcat(str,tmp);
            break;
          case CF_LONG:
            sprintf(tmp,"%d ",((UINT32 *)ca->ams->alarmData)[i]);
            strcat(str,tmp);
            break;
          case CF_FLOAT:
            sprintf(tmp,"%g ",((float *)ca->ams->alarmData)[i]);
            strcat(str,tmp);
            break;
          default:
            sprintf(tmp,"%g ",ca->ams->alarmData[i]);
            strcat(str,tmp);
            break;
        }
      }
      sprintf(&str[strlen(str)],"@%ld",RPCtimestamp);
      din.dFormat = CF_TEXT;
      din.data.cptr = str;
      din.dArrayLength = strlen(str);
      if ((i=AttachLink(ca->devName,"ANNOTATE",NULL,&din,CA_WRITE,100,NULL,CM_SINGLE)) < 0) cc = -i;
    }
  }
  ca->status = cc;
}
void TakeAction(CAS_ACTION *ca)
{
  int lnkID;
  char str[128];

  if (debug) 
  {
    sprintf(dbgbuf,"take action for %s %s\n",ca->devName,ca->devProperty);
    dbgoutput(dbgbuf,tnull);
  }
  ca->status = -1;
  lnkID = AttachLinkEx(ca->devName,ca->devProperty,&ca->dout,&ca->din,(short)ca->access,100,TakeActionCallback,CM_SINGLE,(int)ca);
  if (lnkID < 0)
  {
    ca->status = -lnkID;
    sprintf(str,"Action Link to %s %s : %s",ca->devName,ca->devProperty,erlst[-lnkID]);
    feclog(str);
    logproblem(str);
  }
}
UINT32 getStartFromAlmSet(AMS *almbuf,int num)
{
  int i;
  UINT32 t = (UINT32)time(NULL);
  if (almbuf == NULL || num == 0) return 0;
  for (i=0; i<num; i++)
  {
    if (almbuf[i].timestamp < t) t = almbuf[i].timestamp;
  }
  return t;
}
#define ActionMask (almHEARTBEAT|almOSCILLATION|almTERMINATE)
void ProcessAlarms(int id, int cc)
{
  int i=id-1,n;
  CAMS *cams = NULL;
  CAS_ACTION *ca;
  char str[128];
  UINT32 starttime = 0;

  if (debug) 
  {
    sprintf(dbgbuf,"Process alarms for %s : %s\n",CASList[i].devServer,erlst[cc]);
    dbgoutput(dbgbuf,tnull);
  }
  if (cc) ccerr(cc);
  PrepIncomingAMS(CASList[i].almBuffer,CASList[i].almBuffer,CASList[i].pending);
  starttime = getStartFromAlmSet(CASList[i].almBuffer,CASList[i].pending);
  if (starttime <= 0) 
  {
    CASList[i].pending = 0;
    feclog("process alarms for %s gave an invalid starttime %d",
      CASList[i].devServer,starttime);
    return;
  }
  if ((cams=(CAMS *)calloc(1,sizeof(CAMS))) == NULL) ccerr(out_of_server_memory);
  /* cams->starttime = CASList[i].prevSnapshot.mrt+1; */
  cams->starttime = starttime;
  cams->stoptime = CASList[i].timestamp;
  cams->nalms = CASList[i].pending;
  cams->ams = CASList[i].almBuffer;
  cams->nxt = CASList[i].almList;
  CASList[i].almList = cams;
  /* are there action items related to the incoming alarms ? */
  if (CASList[i].actionList != NULL)
  {
    for (n=0; n<cams->nalms; n++)
    {
      for (ca=CASList[i].actionList; ca != NULL; ca=ca->nxt)
      {
        ca->retry = 3;
	if (ca->alarmCode == cams->ams[n].alarmCode)
	{
          if (cams->ams[n].descriptor & ActionMask) continue;
          ca->ams = &(cams->ams[n]);
	  TakeAction(ca);
	}
      }
    }
  }
err:
  CASList[i].pending = 0; /* clear the pending here in case of retries ... */
  if (cc && CASList[i].linkRetryCounter < 3)
  {
    CASList[i].linkRetryCounter++;
    sprintf(str,"Process Alarm %s : %s",CASList[i].devServer,erlst[cc]);
    feclog(str);
    AcquireAlarmInfo(i); /* try once again */
  }
  else
  {
    CASList[i].linkRetryCounter = 0;
    memcpy(&CASList[i].prevSnapshot,&CASList[i].thisSnapshot,sizeof(ALM_SNAPSHOT));
    /* just to be sure there are no overwrites */
    /* CASList[i].prevSnapshot.mrt = CASList[i].timestamp; */
  }
  return;
}
void AcquireAlarmInfo(int i)
{
  char lnkDevName[64];
  int lnkID;
  DTYPE dout,din;
  AMRB amrb;
  UINT32 buf[4];
  char str[128];

  if (CASList[i].pending) return;
  if (CASList[i].thisSnapshot.nmrt == 0) return;
  if (CASList[i].thisSnapshot.nmrt > 100 || 
      CASList[i].thisSnapshot.nmrt > CASList[i].thisSnapshot.nalm) return; 
  CASList[i].pending = CASList[i].thisSnapshot.nmrt;
  CASList[i].timestamp = CASList[i].thisSnapshot.mrt;
  if ((CASList[i].almBuffer=(AMS *)calloc(CASList[i].thisSnapshot.nmrt,AMS_SIZE)) == NULL)
  {
    sprintf(str,"Insufficient memory for %d alarms for %s",
		CASList[i].thisSnapshot.nmrt,CASList[i].devServer);
    feclog(str);
    return;
  }

  dout.dFormat = CF_STRUCT;
  dout.dArrayLength = AMS_SIZE*CASList[i].thisSnapshot.nmrt;
  dout.data.vptr = CASList[i].almBuffer;
  dout.dTag[0] = 0;
  sprintf(lnkDevName,"/%s/%s/#0",CASList[i].devContext,CASList[i].devServer);

  amrb.almStartTime = CASList[i].prevSnapshot.mrt + 1;
  amrb.almStopTime = CASList[i].timestamp;
  amrb.almMinSeverity = CASList[i].SeverityLevel;
  PrepOutgoingAMRB(&amrb,buf);

  din.dFormat = CF_STRUCT;
  din.dArrayLength = AMRB_SIZE;
  din.data.vptr = buf;
  din.dTag[0] = 0;

  lnkID = AttachLinkEx(lnkDevName,"ALARMSEXT",&dout,&din,CA_READ,1000,ProcessAlarms,CM_SINGLE,i+1);
  if (lnkID < 0)
  {
    sprintf(str,"Alarm Info Link to %s : %s",lnkDevName,erlst[-lnkID]);
    feclog(str);
    logproblem(str);
  }
}
void ClearServerDownAlarm(int i)
{
  if (CASList[i].markedAsDown != TRUE) return;
  feclog("clear server down alarm for %s",CASList[i].devServer);
  CASList[i].markedAsDown = FALSE;
  AppendGeneratedAlarm(i,CASList[i].AlarmSystem,CASList[i].AlarmLevel,almTERMINATE);
  AppendGeneratedAlarm(i,ALMSYSTEM_INFRASTRUCTURE,ALMSYSTEM_FATAL,almTERMINATE);
}
int EmptyAlarmTable(int i)
{
  CAMS *cams = NULL;
  int n;
  
  if (i < 0 || i >= nCASList) return invalid_index;
  for (cams=CASList[i].almList; cams != NULL; cams=cams->nxt)
  {
    for (n=0; n<cams->nalms; n++) 
    {
      if (cams->ams[n].alarmCode == 999) continue;
      if (isDuplicatedAlarm(&(cams->ams[n]),CASList[i].almList)) continue;
      cams->ams[n].descriptor |= almTERMINATE;
    }
  }
  return 0;
}
void TerminateDanglingAlarms(int i)
{
  CAMS *cams = NULL, *pcams = NULL;
  AMS *ams = NULL;
  time_t t = time(NULL);
  int n;
  
  if (i < 0 || i >= nCASList) return;
  for (cams=CASList[i].almList; cams != NULL; cams=cams->nxt)
  {
    for (n=0; n<cams->nalms; n++)
    {
      if (cams->ams[n].descriptor == almNEWALARM)
      {
        if (t > (time_t)(cams->ams[n].timestamp + 2*DEFAULT_ALARM_HEARTBEAT))
        { 
          if (isDuplicatedAlarm(&(cams->ams[n]),CASList[i].almList)) continue;
          goto generateTermination;
        }
      }
    }
  }
  return;
generateTermination:
  if (cams == NULL) return;
  feclog("Generate alarm termination for %s",CASList[i].devServer);
  if ((ams=(AMS *)calloc(1,sizeof(AMS))) == NULL)
  {
    feclog("Insufficient memory for terminate alarm for %s",CASList[i].devServer);
    return;
  }
  if ((pcams=(CAMS *)calloc(1,sizeof(CAMS))) == NULL)
  {
    feclog("Insufficient memory for terminate alarm for %s",CASList[i].devServer);
    return;
  }
  memcpy(ams,&(cams->ams[n]),sizeof(AMS));
  ams->timestamp = t;
  ams->descriptor = almTERMINATE;
  strncpy(ams->alarmTag,"dangling alarm",16);

  pcams->nalms = 1;
  pcams->stoptime = t;
  pcams->starttime = cams->stoptime-1;
  pcams->ams = ams;
  pcams->nxt = CASList[i].almList;
  CASList[i].almList = pcams;
  CASList[i].timestamp = t;

  return;
}
void AppendGeneratedAlarm(int i,int almsys,int almsev,int almdsc)
{
  CAMS *cams = NULL;
  AMS *ams = NULL;
  time_t t = time(NULL);
  
  if ((ams=(AMS *)calloc(1,sizeof(AMS))) == NULL)
  {
    feclog("Insufficient memory for server down alarm for %s",
      CASList[i].devServer);
    return;
  }
  if ((cams=(CAMS *)calloc(1,sizeof(CAMS))) == NULL)
  {
    feclog("Insufficient memory for server down alarm for %s",
      CASList[i].devServer);
    return;
  }
  strncpy(ams->tag,CASList[i].devServer,16);
  strncpy(ams->device,"FEC",16);
  strncpy(ams->alarmTag,"Not Responding",16);
  ams->alarmCode = 999;
  ams->timestamp = t;
  ams->alarmMask = 0;
  ams->alarmDataFormat = BFMT(CF_NULL);
  ams->alarmDataArraySize = 0;
  ams->severity = almsev;
  ams->descriptor = (BYTE)almdsc;
  ams->alarmSystem = almsys;

  cams->nalms = 1;
  cams->stoptime = t;
  cams->starttime = cams->stoptime-1;
  cams->ams = ams;
  cams->nxt = CASList[i].almList;
  CASList[i].almList = cams;
  CASList[i].timestamp = t;

  return;
}
void GenerateServerDownAlarm(int i)
{
  CAMS *cams = NULL;
  AMS *ams = NULL;
  time_t t = time(NULL), mrt = 0;
  int isInList = 0, needsHeartbeat = 0;
  BYTE descriptor = 0;
  
  for (cams=CASList[i].almList; cams != NULL; cams=cams->nxt)
  {
    if (cams->ams->alarmCode == 999 && 
        !strcmp(cams->ams->alarmTag,"Not Responding"))
    {
      isInList = TRUE; /* found it */
      if ((time_t)cams->ams->timestamp > mrt) 
      {
        mrt = cams->ams->timestamp;
        descriptor = cams->ams->descriptor;
      }
    }
  }
  /* check most recent time and descriptor at that time  */
  if ((descriptor & almTERMINATE) == almTERMINATE) isInList = FALSE;
  needsHeartbeat = (t < mrt + DEFAULT_ALARM_HEARTBEAT) ? FALSE : TRUE;
  CASList[i].markedAsDown = TRUE;
  if (isInList)
  {
    if (needsHeartbeat)
    {
      feclog("Generate server down heartbeat for %s",CASList[i].devServer);
      AppendGeneratedAlarm(i,CASList[i].AlarmSystem,CASList[i].AlarmLevel,almHEARTBEAT);
      AppendGeneratedAlarm(i,ALMSYSTEM_INFRASTRUCTURE,ALMSYSTEM_FATAL,almHEARTBEAT);
    }
    return;
  }
  feclog("Generate server down alarm for %s",CASList[i].devServer);
  AppendGeneratedAlarm(i,CASList[i].AlarmSystem,CASList[i].AlarmLevel,almNEWALARM);
  AppendGeneratedAlarm(i,ALMSYSTEM_INFRASTRUCTURE,ALMSYSTEM_FATAL,almNEWALARM);

  return;
}
void CheckAlarms(int id, int cc)
{
  int i=id-1;
  time_t mrt;
  
  if (cc != 0) 
  {
    CASList[i].linkStatus = cc;
    mrt = CASList[i].prevSnapshot.mrt;
    memset(&CASList[i].prevSnapshot,0,sizeof(ALM_SNAPSHOT));
    CASList[i].prevSnapshot.mrt = mrt;
    CASList[i].pending = 0;
    if (CASList[i].linkTimeoutCounter++ > TIMEOUT_THRESHOLD) 
    {
      GenerateServerDownAlarm(i);
      EmptyAlarmTable(i);
    }
    return;
  }
  if (CASList[i].linkStatus != 0) /* server is back */
  {
    feclog("Reconnected to server %s",CASList[i].devServer);
    ClearServerDownAlarm(i);
  }
  CASList[i].linkStatus = cc;
  CASList[i].linkTimeoutCounter = 0;
  if (CASList[i].thisSnapshot.hsv == 0) return;
  if (!memcmp(&CASList[i].thisSnapshot,&CASList[i].prevSnapshot,sizeof(ALM_SNAPSHOT))) return;
  if (CASList[i].thisSnapshot.mrt > CASList[i].prevSnapshot.mrt) 
  {
    if (debug)
    {
      sprintf(dbgbuf,"new alarm information for %s\n",CASList[i].devServer);
      dbgoutput(dbgbuf,tnull);
    }
    AcquireAlarmInfo(i);
  }
}
int findHighestSeverity(CAMS *cams)
{
  int n,hsv=0;

  for (n=0; n<cams->nalms; n++)
  {
    if (cams->ams[n].severity > hsv) hsv = cams->ams[n].severity;
  }
  return hsv;
}
void caseqm_bkg(void)
{
  int i,k,n,hsv;
  time_t t=time(NULL);
  CAMS *cams, *pcams, *ncams;
  static time_t lastAcquired = 0;

  if (needToAcquireAlarmDefs && t > lastAcquired + 10)
  {
    n = 0;
    for (i=0; i<nCASList; i++)
    {
      if (!CASList[i].adsListAcquired) getAlarmDefinitions(&CASList[i]);
      else n++;
    }
    if (n == nCASList) needToAcquireAlarmDefs = FALSE; /* all done */
    lastAcquired = t;
  }

  /* could generate server down alarms this way: */
  /* ClearAlarm(CASEQM_TAG,-1); */
 
  /* is it time to archive alarms and/or free memory ? */
  for (i=0; i<nCASList; i++)
  {
    TerminateDanglingAlarms(i);
    for (cams=CASList[i].almList,pcams=cams; cams != NULL; )
    {
      for (k=0; k<cams->nalms; k++)
      {
        if ((t > cams->starttime + CASList[i].Retention) &&
            (cams->ams[k].descriptor == almNEWALARM))
        {
           feclog("CAS: long term new alarm : %s %s %s",
             CASList[i].devServer,cams->ams[k].device,cams->ams[k].alarmTag);
           feclog("CAS: time now %d > %d + %d",
             t,cams->starttime,CASList[i].Retention);
           /* long-term NEW alarm with no heartbeat ! */
           cams->stoptime = cams->starttime; 
           /* generate terminated alarm ? */
        }
      }
      if (t > cams->stoptime + CASList[i].Retention) /* free memory and archive */
      {
        if ((hsv=findHighestSeverity(cams)) >= 7)
        {
	  ArchiveAMS(cams->nalms,cams->ams,CASList[i].devServer,CASList[i].arcExt,cams->stoptime);
        }
	free(cams->ams);
        /* join ... */
	if (cams == CASList[i].almList) /* first in the list */
        {
          CASList[i].almList = cams->nxt;
        }
	else                            /* somewhere down the chain ... */
        {
          pcams->nxt = cams->nxt;
        }
        ncams = cams->nxt;
        /* free ... */
	free(cams);
        /* re-assign ... */
        cams = ncams;
	continue;
      }
      pcams = cams;
      cams = cams->nxt;
    }
  }
  return;
}
void caseqm_ini(void)
{
  char lnkDevName[64],str[128],*c;
  int cc,i,lnkID;
  DTYPE dout;
  time_t t = time(NULL);

  remove("problems.log");

  RegisterUserCommand("casdebug",NULL,&debug,NULL,CA_WRITE|CA_READ);

  registerStructs();

  if ((cc=getAlarmSystemList(ALARM_SYSTEM_FILE)) != 0)
  {
    feclog("getAlarmSystemList: %s",erlst[cc]);
  }
  if ((cc=getCASList(casListFile)) != 0)
  {
    feclog("CAS Initialization error: %s",erlst[cc]);
    exit(1);  /* stop right here */
  }
  /* use CAS device name = targetted device server */
  for (i=0; i<nCASList; i++)
  {
    CASList[i].prevSnapshot.mrt = t - 3600;
    RegisterDeviceName(CASEQM_TAG,CASList[i].devServer,i);
  }
  /* or CAS device name = targetted sub system */
  for (i=0; i<nAlarmSubSystems; i++)
  {
    RegisterDeviceName(CASEQM_TAG,AlarmSubSystems[i].name,nCASList+i);
  }

  /* start the links to the targetted FECs */
  dout.dFormat = CF_LONG;  /* CAS_SNAPSHOT is 5 longs */
  dout.dArrayLength = 5;
  for (i=0; i<nCASList; i++)
  {
    if (CASList[i].offline) continue;
    dout.data.lptr = (UINT32 *)&CASList[i].thisSnapshot;
    CASList[i].linkId = i + 1; 
    sprintf(lnkDevName,"/%s/%s/#0",CASList[i].devContext,CASList[i].devServer);
    lnkID = AttachLinkEx(lnkDevName,"NALARMS",&dout,NULL,CA_READ,1000,CheckAlarms,CM_REFRESH,i+1);
    if (lnkID < 0)
    {
      sprintf(str,"Alarm Snapshot Link to %s : %s",lnkDevName,erlst[-lnkID]);
      feclog(str);
      logproblem(str);
    }
    else
    { /* everythings okay, so get the alarm definition information */
      if (getAlarmDefinitions(&CASList[i]) != 0) needToAcquireAlarmDefs = TRUE;
    }
  }
  if ((c=GetExportedName(CASEQM_TAG)) != NULL)
    strncpy(casExportName,c,16);
  else 
    strncpy(casExportName,"CAS",16);
  printf("CAS services exported as %s\n",casExportName);
}

void caseqm_exi(void)
{
  int i;
  /* flush the archive queue */
  for (i=0; i<nCASList; i++) CASList[i].Retention = 0;
  caseqm_bkg();
}
/* return TRUE if ams is found previously in cams */
/* note: the most recent alarms are at the head of the linked list */
int isDuplicatedAlarm(AMS *ams, CAMS *pcams)
{
  CAMS *cams;
  int i;
  if (ams->descriptor & almINSTANT) return FALSE;
  for (cams=pcams; cams != NULL; cams=cams->nxt)
  {
    for (i=0; i<cams->nalms; i++)
    {
      if (ams == &(cams->ams[i])) return FALSE;
      if (ams->descriptor & almDISABLED) return TRUE;  /* disabled; */
      if (cams->ams[i].alarmCode != ams->alarmCode) continue;
      if (strncmp(cams->ams[i].tag,ams->tag,16)) continue;
      if (cams->ams[i].device[0] == 0 && ams->device[0] != 0) continue;
      if (cams->ams[i].device[0] != 0 && ams->device[0] == 0) continue;
      if (strlen(ams->device) > 0 &&
          strncmp(cams->ams[i].device,ams->device,16)) continue;
      ams->descriptor |= almDISABLED; /* disable it for future checks */
      return TRUE;
    }
  }
  return FALSE;
}
int numNonTerminatedAlarmsInList(int i,UINT32 start,UINT32 stop,int sev,int sys,int filterLast)
{
  CAMS *cams;
  int j, n = 0;
  int thisAlarmSystem,dftAlarmSystem = CASList[i].AlarmSystem;

  for (cams=CASList[i].almList; cams != NULL; cams=cams->nxt)
  {
    if ((UINT32)cams->stoptime > start && (UINT32)cams->starttime <= stop)
    {
      for (j=0; j<cams->nalms; j++)
      {
        thisAlarmSystem = cams->ams[j].alarmSystem;
        if (thisAlarmSystem == 0) /* wasn't set ! */
          thisAlarmSystem = dftAlarmSystem;
        if (sys > -1 && cams->ams[j].alarmSystem != sys) continue;
        if ( /* !(cams->ams[j].descriptor & almINSTANT) && */
             (cams->ams[j].descriptor & almTERMINATE)) continue;
        if (isDuplicatedAlarm(&(cams->ams[j]),CASList[i].almList) &&
            filterLast) continue;
        if (cams->ams[j].severity >= sev) n++;
      }
    }
  }
  return n;
}
int numAlarmsInList(int i,UINT32 start,UINT32 stop,int sev,int sys,int filterLast)
{
  CAMS *cams;
  int j, n = 0;
  int thisAlarmSystem,dftAlarmSystem = CASList[i].AlarmSystem;

  for (cams=CASList[i].almList; cams != NULL; cams=cams->nxt)
  {
    if ((UINT32)cams->stoptime > start && (UINT32)cams->starttime <= stop) 
    {
      if (sev == 0 && sys == -1) n += cams->nalms;
      else
      {
        for (j=0; j<cams->nalms; j++) 
        {
          thisAlarmSystem = cams->ams[j].alarmSystem;
          if (thisAlarmSystem == 0) /* wasn't set ! */
            thisAlarmSystem = dftAlarmSystem;
          if (sys > -1 && cams->ams[j].alarmSystem != sys) continue;
          if (filterLast && cams->ams[j].descriptor & almDISABLED) continue;
          if (cams->ams[j].severity >= sev) n++;
        }
      }
    }
  }
  return n;
}
int getAlarmSystemNumberFromTag(char *tag)
{
  int i;
  for (i=0; i<nAlarmSystems; i++)
    if (!strncmp(tag,AlarmSystems[i].tag,16)) break;
  return i < nAlarmSystems ? AlarmSystems[i].number : -1;
}
/* improve readability; later: insist that a tagged struct is used! */
#define CASPrepOutgoingAMS(src,dst,siz) {\
  if (isExtended) {\
    CASPrepOutgoingXAMS(cl,src,(XAMS *)dst,siz);\
  } else if (isTaggedStruct) {\
    memcpy(dst,src,(siz)*amssize);\
  } else {\
    PrepOutgoingAMS(src,dst,siz);\
  }\
  dst += (siz)*amssize;\
}
int CASPrepOutgoingXAMS(CAS_LIST *clst,AMS *src,XAMS *dst,int siz)
{
  int i,k,useAlarmText=FALSE;
  
  for (i=0; i<siz; i++)
  {
    strncpy(dst[i].server,src[i].tag,16);
    strncpy(dst[i].device,src[i].device,16);
    useAlarmText = FALSE;
    if (clst->nAdsList > 0)
    {
      for (k=0; k<clst->nAdsList; k++)
      {
        if (src[i].alarmCode == clst->adsList[k].alarmCode)
        {
          strncpy(dst[i].alarmText,clst->adsList[k].alarmText,40);
          if (strlen(dst[i].alarmText) > 0) useAlarmText = TRUE;
          break;
        }
      }
    }
    if (!useAlarmText) strncpy(dst[i].alarmText,src[i].alarmTag,16);
    dst[i].alarmCode = src[i].alarmCode;
    dst[i].timestamp = src[i].timestamp;
    dst[i].alarmMask = src[i].alarmMask;
    dst[i].alarmSystem = src[i].alarmSystem;
    memcpy(dst[i].alarmData,src[i].alarmData,6);
    dst[i].alarmDataFormat = src[i].alarmDataFormat;
    dst[i].alarmDataArraySize = src[i].alarmDataArraySize;
    dst[i].severity = src[i].severity;
    dst[i].descriptor = src[i].descriptor;
  }
  return 0;
}
int caseqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int devnr,prpid,almsysnr,i,k,n,cc,len,siz,sev = 0,chkss;
  int addAlarmCode=0,dftAlarmSystem=0,thisAlarmSystem,filterLast=0;
  int almcode,isTaggedStruct=FALSE,isExtended=FALSE,isAllowed=FALSE;
  int amssize=AMS_SIZE;
  CAS_LIST *cl;
  time_t stoptime = time(NULL), starttime = stoptime - 60, mrt = 0;
  short lcl_numalarms, lcl_nntalarms, lcl_nalm[2];
  CAMS *cams;
  BYTE *ptr;
  char *c;
  UINT32 *lptr;

  /* get device number from device name  */
  devnr = GetDeviceNumber(CASEQM_TAG,devName); /* -1 => ALL  */
  almsysnr = -1; /* ALL */
  if ((c=strstr(devName,"SYS#")) != NULL) 
    almsysnr = atoi(&c[4]);
  else if ((c=strstr(devName,"SYS:")) != NULL) 
    almsysnr = getAlarmSystemNumberFromTag(&c[4]);
  prpid = GetPropertyId(CASEQM_TAG,devProperty);

  switch (prpid)
  {
    case PRP_ISONLINE:
        if (devnr >= 0) 
        {
          if (dout->dFormat != CF_SHORT && dout->dFormat != CF_LONG) 
            return illegal_format;
          for (n=0,i=devnr; n<(int)dout->dArrayLength && i<nCASList; n++, i++)
          {
            k = (CASList[i].offline || CASList[i].markedAsDown) ? 0 : 1;
            if (dout->dFormat == CF_SHORT) 
              dout->data.sptr[n] = k;
            else 
              dout->data.lptr[n] = k;
          }
          dout->dArrayLength = n;
        }
        return 0;
    case PRP_REMOVEALARMS:
        if (access&CA_WRITE) return EmptyAlarmTable(devnr);
        return illegal_read_write;
    case PRP_ACKTIME:
        if (access&CA_WRITE) 
        {
          if (din->dArrayLength == 0) return illegal_read_write;
          if ((cc=getValuesAsLong(din,(UINT32 *)&g_AckThreshold,1)) != 0) return cc;
        }
        if (dout->dArrayLength > 0)
        {
          return putValuesFromLong(dout,(UINT32 *)&g_AckThreshold,1);
        }
        return 0;
    case PRP_SYSALARMS:
        filterLast = -1;
    case PRP_RAWSYSALARMS:
        if (access&CA_WRITE) return illegal_read_write;
        if (din->dArrayLength > 0)
        {
          switch (din->dFormat)
          {
            case CF_SHORT:
              starttime = stoptime - din->data.sptr[0]*60;
              break;
            case CF_LONG:
              if ((din->dArrayLength > 2)) sev = din->data.lptr[2];
              if ((din->dArrayLength > 1) && (i=(int)din->data.lptr[1]) > 0)
                 stoptime = din->data.lptr[0];
              if ((i=(int)din->data.lptr[0]) > 0) starttime = din->data.lptr[0];
              else starttime = stoptime + i;
              break;
            default:
              return illegal_format;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dFormat != CF_STRUCT) return illegal_format;
          ptr = dout->data.bptr;
          if (!strcmp(dout->dTag,"AMS"))
          {
            n = dout->dArrayLength;
            isTaggedStruct = TRUE;
          }
          else if (!strcmp(dout->dTag,"XAMS"))
          {
            n = dout->dArrayLength;
            isExtended = TRUE;
            amssize = XAMS_SIZE;
          }
          else
          {
            if (dout->dArrayLength%AMS_SIZE) return illegal_read_write;
            if ((n=dout->dArrayLength/AMS_SIZE) == 0) return buffer_too_small;
          }
          if (devnr < 0) /* all */
          {
            for (i=0; i<nCASList; i++)
            {
              cl = &CASList[i];
              dftAlarmSystem = CASList[i].AlarmSystem;
              for (cams=CASList[i].almList; cams != NULL; cams = cams->nxt)
              {
                if ((time_t)cams->stoptime <= starttime || 
                    (time_t)cams->starttime > stoptime) continue;
                if (sev == 0 && almsysnr == -1)
                {
                  CASPrepOutgoingAMS(cams->ams,ptr,cams->nalms);
                }
                else
                {
                  for (n=0; n<cams->nalms; n++)
                  {
                    thisAlarmSystem = cams->ams[n].alarmSystem;
                    if (thisAlarmSystem == 0) /* wasn't set ! */
                      thisAlarmSystem = dftAlarmSystem;
                    if (almsysnr > -1 && 
                        thisAlarmSystem != almsysnr) continue;
                    if (filterLast && 
                        cams->ams[n].descriptor & almDISABLED) continue;
                    if (filterLast && 
                        /* !(cams->ams[n].descriptor & almINSTANT) && */
                        (cams->ams[n].descriptor & almTERMINATE)) continue;
                    if (cams->ams[n].severity < sev) continue;
                    CASPrepOutgoingAMS(&cams->ams[n],ptr,1);
                  }
                }
              }
            }
          }
          else if (devnr >= nCASList) /* subsystem */
          {
            for (i=0; i<nCASList; i++)
            {
              if (strncmp(devName,CASList[i].subSystem,16)) continue;
              cl = &CASList[i];
              for (cams=CASList[i].almList; cams != NULL; cams = cams->nxt)
              {
                if ((time_t)cams->stoptime <= starttime || 
                    (time_t)cams->starttime > stoptime) continue;
                if (sev == 0)
                {
                  CASPrepOutgoingAMS(cams->ams,ptr,cams->nalms);
                }
                else
                {
                  for (n=0; n<cams->nalms; n++)
                  {
                    if (filterLast &&
                        cams->ams[n].descriptor & almDISABLED) continue;
                    if (filterLast && 
                        /* !(cams->ams[n].descriptor & almINSTANT) && */
                        (cams->ams[n].descriptor & almTERMINATE)) continue;
                    if (cams->ams[n].severity < sev) continue;
                    CASPrepOutgoingAMS(&cams->ams[n],ptr,1);
                  }
                }
              }
            }
          }
          else /* targetted device server */
          {
            cl = &CASList[devnr];
            for (cams=CASList[devnr].almList; cams != NULL; cams = cams->nxt)
            {
              if ((time_t)cams->stoptime <= starttime || 
                  (time_t)cams->starttime > stoptime) continue;
              if (sev == 0)
              {
                CASPrepOutgoingAMS(cams->ams,ptr,cams->nalms);
              }
              else
              {
                for (n=0; n<cams->nalms; n++)
                {
                  if (filterLast &&
                      cams->ams[n].descriptor & almDISABLED) continue;
                  if (filterLast && 
                      /* !(cams->ams[n].descriptor & almINSTANT) && */
                      (cams->ams[n].descriptor & almTERMINATE)) continue;
                  if (cams->ams[n].severity < sev) continue;
                  CASPrepOutgoingAMS(&cams->ams[n],ptr,1);
                }
              }
            }
          }
        }
        return 0;
    case PRP_NUMALARMS:
        filterLast = -1;
    case PRP_RAWNUMALARMS:
        if (access&CA_WRITE) return illegal_read_write;
        if (din->dArrayLength > 0)
        {
          switch (din->dFormat)
          {
            case CF_SHORT:
              starttime = stoptime - din->data.sptr[0]*60;
              break;
            case CF_LONG:
              if ((din->dArrayLength > 2)) sev = din->data.lptr[2];
              if ((din->dArrayLength > 1) && (i=(int)din->data.lptr[1]) > 0)
                 stoptime = i;
              if ((i=(int)din->data.lptr[0]) > 0) starttime = din->data.lptr[0];
              else starttime = stoptime + i;
              break;
            default:
              return illegal_format;
          }
        }
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > 2) return dimension_error;
          lcl_numalarms = 0; lcl_nntalarms = 0;
          if (devnr < 0) /* all */
          {
            for (i=0; i<nCASList; i++) 
            {
              lcl_numalarms += numAlarmsInList(i,starttime,stoptime,sev,almsysnr,filterLast);
              lcl_nntalarms += numNonTerminatedAlarmsInList(i,starttime,stoptime,sev,almsysnr,filterLast);
              if (CASList[i].timestamp > mrt) mrt = CASList[i].timestamp;
            }
          }
          else if (devnr >= nCASList) /* subsystem */
          {
            for (i=0; i<nCASList; i++)
            {
              if (strncmp(devName,CASList[i].subSystem,16)) continue;
              lcl_numalarms += numAlarmsInList(i,starttime,stoptime,sev,almsysnr,filterLast);
              lcl_nntalarms += numNonTerminatedAlarmsInList(i,starttime,stoptime,sev,almsysnr,filterLast);
              if (CASList[i].timestamp > mrt) mrt = CASList[i].timestamp;
            }
          }
          else /* targetted device server */
          {
            lcl_numalarms = numAlarmsInList(devnr,starttime,stoptime,sev,almsysnr,filterLast);
            lcl_nntalarms = numNonTerminatedAlarmsInList(devnr,starttime,stoptime,sev,almsysnr,filterLast);
            mrt = CASList[devnr].timestamp;
          }
          lcl_nalm[0] = lcl_numalarms;
          lcl_nalm[1] = lcl_nntalarms;
          if ((cc=putValuesFromShort(dout,lcl_nalm,2)) != 0) return cc;
          /* if no alarm found, set the mrt to now minus 2 hours */
          if (mrt == 0) mrt = time(NULL) - 7200;
          setDataTimeStamp(mrt);
        }
        return 0;
    case PRP_SERVERINFO:
        if (devnr < 0 || devnr >= nCASList) return illegal_equipment_number;
        if (dout->dFormat != CF_STRUCT || strncmp(dout->dTag,"CASQS",8)) return illegal_format;
        if (dout->dArrayLength != 1) return dimension_error;
        
        strncpy(((CASQS *)(dout->data.vptr))->devContext,CASList[devnr].devContext,16);
        strncpy(((CASQS *)(dout->data.vptr))->devServer,CASList[devnr].devServer,16);
        strncpy(((CASQS *)(dout->data.vptr))->subSystem,CASList[devnr].subSystem,16);
        strncpy(((CASQS *)(dout->data.vptr))->arcExt,CASList[devnr].arcExt,16);
        ((CASQS *)(dout->data.vptr))->SeverityLevel = CASList[devnr].SeverityLevel;
        ((CASQS *)(dout->data.vptr))->ArchiveLevel = CASList[devnr].ArchiveLevel;
        ((CASQS *)(dout->data.vptr))->Retention = CASList[devnr].Retention;
        ((CASQS *)(dout->data.vptr))->AlarmLevel = CASList[devnr].AlarmLevel;
        ((CASQS *)(dout->data.vptr))->AlarmSystem = CASList[devnr].AlarmSystem;

        return 0;
    case PRP_SUBSYSTEMS:
        if ((siz=dout->dArrayLength) > 0)
        {
          switch (dout->dFormat)
          {
            case CF_NAME8: 
            case CF_NAME16:
            case CF_NAME32:
            case CF_NAME48:
            case CF_NAME64: len = fmtsizeof(dout->dFormat); break;
            case CF_USTRING:
            case CF_INTINT: len = 0; break;
            case CF_TEXT: len = 16; siz = siz/16; break;
            default : return illegal_format;
          }
          for (i=0; i<siz && i<nAlarmSubSystems; i++)
          {
            if (len > 0)
              strncpy(dout->data.cptr+i*len,AlarmSubSystems[i].name,16);
            if (dout->dFormat == CF_INTINT)
            {
              ((INTINT *)dout->data.vptr)[i].i1val = AlarmSubRanges[i].i1val;
              ((INTINT *)dout->data.vptr)[i].i2val = AlarmSubRanges[i].i2val;
            }
            if (dout->dFormat == CF_USTRING)
            {
              strncpy(dout->data.cptr+i*96+16,AlarmSubSystems[i].name,16);
              ((DUSTRING *)dout->data.vptr)[i].f1val = (float)AlarmSubRanges[i].i1val;
              ((DUSTRING *)dout->data.vptr)[i].f2val = (float)AlarmSubRanges[i].i2val;
            }
	  }
          dout->dArrayLength = dout->dFormat == CF_TEXT ? i*len : i;
        }
        return 0;
    case PRP_ALARMSYSTEMS:
        if ((siz=dout->dArrayLength) > 0)
        {
          switch (dout->dFormat)
          {
            case CF_NAME16I:
            case CF_NAME32I:
            case CF_NAME48I:
            case CF_NAME64I: 
              addAlarmCode = TRUE;
            case CF_NAME16:
            case CF_NAME32:
            case CF_NAME48:
            case CF_NAME64: 
              len = fmtsizeof(dout->dFormat); 
              break;
            default : 
              return illegal_format;
          }
          for (i=0; i<siz && i<nAlarmSystems; i++)
          {
            strncpy(dout->data.cptr+i*len,AlarmSystems[i].tag,16);
            if (addAlarmCode) 
              *(UINT32 *)(dout->data.bptr+(i+1)*len - 4) = AlarmSystems[i].number;
	  }
          dout->dArrayLength = i;
        }
        return 0;
    case PRP_SERVERS:
        if ((siz=dout->dArrayLength) > 0)
        {
          switch (dout->dFormat)
          {
            case CF_NAME8: len = 8; break;
            case CF_NAME16: len = 16; break;
            case CF_NAME32: len = 32; break;
            case CF_NAME48: len = 48; break;
            case CF_TEXT: len = 16; siz = siz/16; break;
            default : return illegal_format;
          }
          chkss = (devnr >= nCASList) ? -1 : 0;
          for (i=0,n=0; i<siz && i<nCASList; i++)
          {
            if (chkss && strncmp(devName,CASList[i].subSystem,16)) continue;
            strncpy(dout->data.cptr+n*len,CASList[i].devServer,16);
            n++;
          }
          dout->dArrayLength = dout->dFormat == CF_TEXT ? n*len : n;
        }
        return 0;
    case PRP_SYSALMDEFS:
        if (devnr < 0 || devnr >= nCASList) return illegal_equipment_number;
        if (dout->dArrayLength == 0) return illegal_read_write;
        if (dout->dFormat != CF_STRUCT) return illegal_format;
        if (strcmp(dout->dTag,"ADS")) return illegal_format;
        almcode = -1;
        if (din->dArrayLength > 0)
        {
          if ((cc=getValuesAsLong(din,(UINT32 *)&almcode,1)) != 0) return cc;
        }
        n = 0;
        ptr = dout->data.bptr;
        for (i=0; i<CASList[devnr].nAdsList; i++)
        {
          if (almcode > 0 && 
              almcode != (int)CASList[devnr].adsList[i].alarmCode) continue;
          if (n++ >= (int)dout->dArrayLength) break;
          memcpy(ptr,&CASList[devnr].adsList[i],ADS_SIZE);
          ptr += ADS_SIZE;
        }
        /* dout->dArrayLength = n; */
        return 0;
    case PRP_SYSALARMSEXT:
        return not_implemented;
    case PRP_SYSTEMLIST:
        if (devnr >= nCASList) return illegal_equipment_number;
        if ((siz=dout->dArrayLength) > 0)
        {
          if ((n=CASList[devnr].nAlmSystemList) > 0)
          {
            lptr = (UINT32 *)CASList[devnr].almSystemList;
          }
          else
          {
            n = 1;
            lptr = (UINT32 *)&CASList[devnr].AlarmSystem;
          }
          if ((cc=putValuesFromLong(dout,lptr,(short)n)) != 0) return cc;
          if (siz > n) dout->dArrayLength = n;
        }
        return 0;
    case PRP_SERVERLIST:
        if (almsysnr < 0) return illegal_equipment_number;
        if ((siz=dout->dArrayLength) > 0)
        {
          switch (dout->dFormat)
          {
            case CF_NAME16:
            case CF_NAME32:
            case CF_NAME48: 
            case CF_NAME64:
              len = fmtsizeof(dout->dFormat); break;
            default : return illegal_format;
          }
          for (i=0,n=0; i<siz && i<nCASList; i++)
          {
            isAllowed = CASList[i].AlarmSystem == almsysnr ? TRUE : FALSE;
            if (!isAllowed && CASList[i].nAlmSystemList > 0)
            {
              for (k=0; k<CASList[i].nAlmSystemList; k++)
              {
                if (CASList[i].almSystemList[k] == almsysnr)
                {
                  isAllowed = TRUE;
                  break;
                }
              }
            }
            if (isAllowed)
            {
              strncpy(dout->data.cptr+n*len,CASList[i].devServer,16);
              n++;
            }
          }
          dout->dArrayLength = n;
        }
        return 0;
    default:
        return illegal_property;
  }
}
int logproblem(char *text,...)
{
  int len,cc=0;
  double ts = makeDataTimeStamp();
  char str[256];
  FILE *fp = NULL;
  va_list args;
  if (strlen(text) > 80) ccerr(string_too_long);
  va_start(args,text);
  sprintf(str,"%s : ",getDataTimeString(ts,0));
  vsprintf(&str[strlen(str)],text,args);
  if (str[strlen(str)-1] != '\n') strcat(str,"\n");
  va_end(args);
  if ((fp=fopen("problems.log","a")) == NULL) ccerr(file_error);
  fwrite(str,len=strlen(str),1,fp);
err:
  if (fp) fclose(fp);
  return cc;
}

