/*
 * CASEQM.h    REVISION HISTORY:
 * Generated by SRVWIZARD on Fri Jan 26 18:01:41 2001
*/

#ifndef CASEQM_H_
#define CASEQM_H_

#ifndef ccerr
# define ccerr(i) { cc = i; goto err; }
#endif

#if defined(MSDOS) || defined(WINNT)
# define DEFAULT_ARCHIVE_PATH "CACHE"
# define SEPARATER "\\"
#else
# define SEPARATER "/"
# define DEFAULT_ARCHIVE_PATH "../CACHE"
#endif

#ifndef INTEL
# define PrepOutgoingAMRB(rb,buf) {\
   SwapBytes((char *)rb,4,CF_LONG,LTOR);\
   memcpy(buf,rb,AMRB_SIZE);\
  }
# define PrepIncomingAMS(amsstruct,buf,n)  {\
   _StructSwapEx(AMSStructStruct,(unsigned char *)buf,(unsigned char *)amsstruct,RTOL,n,sizeof(AMS));\
  }
#else
# define PrepOutgoingAMRB(rb,buf) memcpy(buf,rb,AMRB_SIZE)
# define PrepIncomingAMS(amsstruct,buf,n) {if ((void *)buf != (void *)amsstruct) memcpy(amsstruct,buf,n*AMS_SIZE); }
#endif

#define CASEQM_TAG "CASEQM"

#define CASEQM_RATE 1000
#define TIMEOUT_THRESHOLD 10

#define PRP_SYSALARMS 2
#define PRP_SYSALARMS_SIZE 1000
#define PRP_NUMALARMS 1
#define PRP_NUMALARMS_SIZE 1
#define PRP_SUBSYSTEMS 3
#define PRP_SERVERS 4
#define PRP_SERVERINFO 5
#define PRP_SERVERINFO_SIZE (16*4 + 4*5)
#define PRP_ACKTIME 6
#define PRP_ACKTIME_SIZE 1
#define PRP_ALARMSYSTEMS 7
#define PRP_ALARMSYSTEMS_SIZE 1000
#define PRP_REMOVEALARMS 8
#define PRP_RAWSYSALARMS 9
#define PRP_RAWNUMALARMS 10
#define PRP_SYSALMDEFS 11
#define PRP_SYSALARMSEXT 12
#define PRP_SYSTEMLIST 13
#define PRP_SERVERLIST 14
#define PRP_ISONLINE 15

#define ALMSYSTEM_INFRASTRUCTURE 5000
#define ALMSYSTEM_FATAL 12

typedef struct CASActionStruct
{
  char devName[64];
  char devProperty[32];
  DTYPE din;
  DTYPE dout;
  int access;
  int actionLevel;
  UINT32 alarmCode;
  AMS *ams;
  int status;
  int retry;
  struct CASActionStruct *nxt;
} CAS_ACTION;

typedef struct CASAlarmMsgStruct
{
  time_t starttime;
  time_t stoptime;
  int nalms;
  AMS *ams;
  struct CASAlarmMsgStruct *nxt;
} CAMS;

typedef struct
{
  UINT32 nalm;  /* number of alarms */
  UINT32 mrt;   /* most recent timestamp */
  UINT32 hsv;   /* highest severity */
  UINT32 nmrt;  /* number at most recent timestamp */
  UINT32 nhsv;  /* number at higest severity */
} ALM_SNAPSHOT;

typedef struct
{
  char devContext[16];
  char devServer[16];
  char subSystem[16];
  char arcExt[16];
  int SeverityLevel;
  int ArchiveLevel;
  int Retention;
  int AlarmLevel;
  int AlarmSystem;
  CAS_ACTION *actionList;
  int linkId;
  int linkStatus;
  int linkTimeoutCounter;
  int linkRetryCounter;
  int markedAsDown;
  ALM_SNAPSHOT thisSnapshot;
  ALM_SNAPSHOT prevSnapshot;
  CAMS *almList;
  AMS *almBuffer;
  ADS *adsList;
  int nAdsList;
  int *almSystemList;
  int nAlmSystemList;
  int adsListAcquired;
  time_t timestamp;
  int pending;
  int offline;
} CAS_LIST;

extern CAS_LIST *CASList;
extern int nCASList;

typedef struct
{
  char devContext[16];
  char devServer[16];
  char subSystem[16];
  char arcExt[16];
  int SeverityLevel;
  int ArchiveLevel;
  int Retention;
  int AlarmLevel;
  int AlarmSystem;
} CASQS; /* CAS QUERY STRUCTURE */

typedef struct
{
  int number;
  char tag[16];
  char subsystem[16];
} ALARMSYSTEM;
extern int nAlarmSystems;
extern ALARMSYSTEM *AlarmSystems;

typedef struct XAlarmMsgStruct
{
  char server[16];
  char device[16];
  char alarmText[40];
  UINT32 alarmCode;
  time_t timestamp;
  UINT32 alarmMask;
  UINT32 alarmSystem;
  BYTE alarmData[8];
  BYTE alarmDataFormat;
  BYTE alarmDataArraySize;
  BYTE severity;
  BYTE descriptor;
} XAMS;                    /* eXtended AMS sent out upon request */
#define XAMS_SIZE  100

#define ALARM_SYSTEM_FILE "AlarmCodes.csv"
#define CAS_LIST_FILE "ServerList.csv"

extern int nAlarmSubSystems;
extern NAME16 *AlarmSubSystems;

extern AMS g_sysalarmsBuffer[PRP_SYSALARMS_SIZE];
extern short g_numalarms;

void TerminateDanglingAlarms(int i);
void TakeAction(CAS_ACTION *ca);
int caseqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access);
void caseqm_bkg(void);
void caseqm_ini(void);
void caseqm_exi(void);

int SimulateData(int start,int range);

char *SimulateStringData(int length);

#endif

