/*
 * devsrv    REVISION HISTORY:
 * Generated by SRVWIZARD on Fri Jan 26 18:01:41 2001
*/

#include "app_version.h"
#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <signal.h>
#include "errors.h"
#include "rpctypes.h"
#include "swaplib.h"
#include "almsrv.h"
#include "servdef.h"
#include "toolkit.h"
#include "caseqm.h"
#include "arctools.h"
#include "lpceqm.h"
#if defined(UNIX)
# include "unixcmd.h"
#elif defined(WINNT)
# include "ntcmd.h"
#endif

int SimulateData(int start,int range)
{
  return start + rand()%(range);
}

char *SimulateStringData(int length)
{
  static char lclStringBuffer[512];
  time_t t = time(NULL);
  static int counter = 1;
  sprintf(lclStringBuffer,"%d : Simulated String generated %s",counter++,ctime(&t));
  if (length < 0) length = 0;
  if (length < 512) lclStringBuffer[length] = 0;
  return lclStringBuffer;
}
int g_isTerminating = FALSE;
void term_handler(int signum)
{
  g_isTerminating = TRUE;
  feclog("caught SIGTERM");
}
void PreSystemInit(void)
{
  signal(SIGTERM,term_handler);

  /* Some System Parameters and their default values    */
  /* are shown below.  You may change them as necessary */
  MinPollingRate = 1000;
  MaxPollingRate = 30000;
  MaxNumContracts = 1000;
  MaxNumClients = 100;
  MaxNumConnections = 500;
  FeclogDepth = 100;
  StartupDebug = TRUE;
  RequireAcknowledgments = TRUE;
  MaxRPCTransportSize = 65535*4;
  gRetardSingleContractRemoval = FALSE;

  isCentralAlarmServer(TRUE);
}

void PostSystemInit(void)
{
  archiveListFile = CAS_LIST_FILE; /* set this to the cas list file */
  RegisterEquipmentModule(NULL,CASEQM_TAG,0,caseqm,caseqm_ini,caseqm_bkg,CASEQM_RATE,caseqm_exi);
  RegisterEquipmentModule(NULL,"FILER",0,filer,filerinit,filertask,100,NULL);
}
int main(int argc, char *argv[])
{
  int cc;
  /* TODO: modify command line input to suit your own needs. */
  /* Here: the debug level is set according to initial input */
  switch (argc)
  {
    case 2:
      NGdebug = atoi(argv[1]);
      break;
    default:
      NGdebug = 0;
  }

  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);
  /* To deviate from default settings, initialize */
  /* any system variables in PreSystemInit() */

  PreSystemInit();

  /* initialize RPC server: */

  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf(erlst[cc]);
    exit(1);
  }

  /* Make all other registrations in PostSystemInit() */

  PostSystemInit();

  for(;;)
  {
    /* TODO: add any additional non-TINE processing here */
    /*       being careful not to block operations */
    if (g_isTerminating) quit(NULL,NULL);
    SystemCycle(TRUE);
  }
  return 0;
}
