#ifndef ulong
# define ulong UINT32
#endif

typedef struct
{
  short numProperties;
  short numDevices;
  long  eventCode;
  char  comment[64];
} AIB;  // Archive Info Block
#define AIBStructSize (2*2+4+64)
typedef struct
{
  float SamplingRate;
  long  numPreTriggerValues;
  long  TimeOffset;
  long  LowCount;
  long  HighCount;
  char  Units[16];
  double LowEGU;
  double HighEGU;
  short  numDevices;
  short  reserved;
} PIB;  // Property Info Block
#define PIBStructSize (5*4+16+2*8+2*2)

typedef struct
{
   char channelID[32]; /* Kanalidentifikator                         */
   UINT32 eventcode;   /* Ereignisbewerter                           */
   UINT16 arraysize;   /* Anzahl der Daten                           */
   UINT16 datatype;    /* Datentyp                                   */
   float samplingrate; /* Abtastfrequenz                             */
   UINT32 pretrigger;  /* Anzahl der Daten vor dem Triggerzeitpunkt  */
   UINT32 timeoffset;  /* Zeitoffset                                 */
   UINT32 lowcount;    /* kleinster Mewert in digits                */
   UINT32 highcount;   /* grter Mewert in digits                  */
   char egu[16];       /* physikalische Einheit                      */
   float egulow;       /* kleinster Mewert in physikalischer Einheit*/
   float eguhigh;      /* grter Mewert in physikalischer Einheit  */
   UINT32 datalength;  /* supercedes arraysize, when arraysize = -1  */
   char desc[4][64];   /* 4x Kommentarzeile                          */
} DHS;  // Data Header Structure
#define DHSStuctSize (32 + 4 + 2*2 + 4 + 4*4 + 16 + 4*2 + 4 + 4*64)

typedef struct
{
  char  deviceServerName[16];
  char  deviceProperty[16];
  char  deviceName[16];
  short dataFormat;
  short dataDimension;
} DEVSPEC; // Device Specifier

typedef struct
{
  ulong   eventNumber;
  time_t  starttime;
  time_t  stoptime;
  DEVSPEC devSpecifier;
} ADRB; // Archived Data Request Block

#define ADRBStructSize (3*4 + 3*16 + 2*2)

typedef struct
{
  char  deviceContext[16];
  char  deviceServerName[16];
  char  deviceProperty[32];
  char  deviceName[32];
  short dataFormat;
  short reserved;
  ulong dataIndex;
  ulong dataDimension;
} DEVSPECX; // Extended Device Specifier

typedef struct
{
  ulong    eventNumber;
  time_t   starttime;
  time_t   stoptime;
  DEVSPECX devSpecifier;
} ADRBX; // Extended Archived Data Request Block

#define ADRBXStructSize (3*4 + 2*16 + 2*32 + 2*2 + 2*4)

