#ifndef ulong
# define ulong unsigned long
#endif
#ifndef BYTE
# define BYTE unsigned char
#endif
typedef struct AEStag
{
  ulong eventNumber;
  ulong eventCode;
  char comment[4][64];
  BYTE dsMask[32];
} AES;

int initArchiveServer(void);
int initRPC(void);
int SetGlobalEvent(ulong eventCode,char *cmt);
int RecordEvent(ulong eventNumber,ulong eventCode,char *devName);

void setTriggerCallback(int (*fcn)(ulong eventNumber,ulong eventCode));
void setRecordEventCallback(void (*fcn)(int cc));
void setSetEventCallback(void (*fcn)(ulong evntnr,int cc));
void setRemoveArchiveEventFunction(int (*fcn)(ulong eventNumber,char *dsrv));
void setRemoveArchiveEventsFunction(int (*fcn)(ulong eventFirst,ulong eventLast,char *dsrv));
void setAnnotateArchiveEventFunction(int (*fcn)(ulong eventNumber,char *dsrv,char *cmt));
void setGetArchiveDataFunction(int (*fcn)(BYTE *data,ulong eventNumber,time_t starttime,time_t stoptime,char *eventContext,DEVSPEC *devSpecifier));
void setGetArchiveHeaderFunction(int (*fcn)(DHS *dhs,ulong eventNumber,time_t starttime,time_t stoptime,char *eventContext,DEVSPEC *devSpecifier));
void setQueryArchiveInfoFunction(int (*fcn)(AIB *aib,ulong eventNumber,char *deviceServer));
void setQueryPropertyInfoFunction(int (*fcn)(PIB *pib,ulong eventNumber,char *deviceServer,char *devProperty));
void setQueryNumLocalArchivedEventsFunction(int (*fcn)(ulong starttime,ulong stoptime,ulong eventNumber));
void setQueryLocalArchivedEventsFunction(int (*fcn)(ulong starttime,ulong stoptime,AES *aes,ulong num));
void setQueryNumLocalDeviceServersFunction(int (*fcn)(void));
void setQueryNumLocalDevicesFunction(int (*fcn)(char *devServer,char *context,int id));
void setQueryNumLocalDevicePropertiesFunction(int (*fcn)(char *devServer,char *devName));
void setQueryLocalDeviceNamesFunction(int (*fcn)(NAME16 *names,char *devServer,char *context,int id, int num));
void setQueryLocalDeviceServerNamesFunction(int (*fcn)(NAME16 *names,ulong start,ulong stop,int id,int num));
//void setQueryLocalDeviceServerNamesFunction(int (*fcn)(NAME16 *names,char *devSrvName,int id,int num));
void setQueryLocalDevicePropertiesFunction(int (*fcn)(NAME16 *properties,char *devSrvName,char *devName,int num));
void setQueryNumDeviceArchivedEventsFunction(int (*fcn)(char *devsrv,char *device,ulong starttime,ulong stoptime));
void setQueryDeviceArchivedEventsFunction(int (*fcn)(char *devsrv,char *device,ulong starttime,ulong stoptime,AES *aes,ulong num));
void setQueryDeviceArchivedEventListFunction(int (*fcn)(char *devsrv,char *device,ulong starttime,ulong stoptime,ulong *evn,ulong num));

int GetNumberOfEvents(time_t starttime,time_t stoptime);
int GetEvents(time_t starttime,time_t stoptime,ulong eventCode,AES *aes,int *num);
int GetNumberOfArchiveServers(void);
int GetArchiveServers(int idSrv,NAME16 *asrv,int *num);
int GetNumberOfDeviceServers(char *archiveServer);
int GetDeviceServersX(char *archiveServer,int idDev,NAME16 *dsrv,int *num);
int GetRemoteArchiveData(char *archiveServer,BYTE *data,ulong eventNumber,time_t starttime,time_t stoptime,DEVSPEC *devSpecifier);
int GetRemoteArchiveHeader(char *archiveServer,DHS *dhs,ulong eventNumber,time_t starttime,time_t stoptime,DEVSPEC *devSpecifier);

int GetArchiveInfo(char *archiveServer,char *deviceServer,ulong evnnum,AIB *aib);
int GetPropertyInfo(char *archiveServer,char *deviceServer,char *deviceProperty,ulong evnnum,PIB *pib);
int GetNumArchiveServerEvents(char *archiveServer,ulong starttime,ulong stoptime,ulong eventNumber);
int GetNumArchiveDeviceServers(char *archiveServer);
int GetNumArchiveDevices(char *archiveServer,char *devServer);
int GetNumArchiveDeviceProperties(char *archiveServer,char *devServer);
int GetArchiveDeviceServerNames(char *archiveServer,unsigned long start,unsigned long stop,NAME16 *names,int *num);
#define GetArchiveDeviceServers(as,start,stop,nam,no) GetArchiveDeviceServerNames(as,start,stop,nam,no)
int GetArchiveDeviceNames(char *archiveServer,char *devServer,NAME16 *names,int *num);
#define GetDeviceNames(as,ds,nam,no) GetArchiveDeviceNames(as,ds,nam,no)
#define GetArchiveDevices(as,ds,nam,no) GetArchiveDeviceNames(as,ds,nam,no)
int GetArchiveDeviceProperties(char *archiveServer,char *devServer,char *devName,NAME16 *properties,int *num);
int GetArchivedEvents(char *archiveServer,time_t starttime,time_t stoptime,ulong eventCode,AES *aes,int *num);
int GetNumDeviceArchivedEvents(char *archiveServer,char *devServer,char *device,ulong starttime,ulong stoptime);
int GetDeviceArchivedEvents(char *archiveServer,char *devServer,char *device,ulong starttime,ulong stoptime,AES *aes,int *num);
int GetDeviceArchivedEventList(char *archiveServer,char *devServer,char *device,ulong starttime,ulong stoptime,ulong *evnlst,int *num);
