// this is the contact equipment module which works together with
// the archive server example.
// It should not be edited.

#include "project.def"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "errors.h"
#include "eventlst.h"
#include "srvlst.h"
#include "rpctypes.h"
#include "swaplib.h"
EXPORTTAG char *getClientName(void);
DEV *registerDevices(char *srvName,int idSrv);
EXPORTTAG int findcol(char *str,char *tag);
EXPORTTAG char *colptr(int col,char *str);
void registerStructs(void);
#define ccerr(i) { cc = i; goto err; }

EventList ArchiveEvent;
ServerList ArchiveServerList;
extern int NGdebug;

int getDeviceID(char *strArchiveServer,char *deviceName)
{
  SRV *srv;
  DEV *dev;

  if ((srv=ArchiveServerList.getSRVfromName(strArchiveServer)) == NULL)
    return -non_existent_client;
  for (dev=srv->devlst; dev != NULL; dev=dev->Next)
    if (!strcmp(dev->devName.name,deviceName)) return dev->idDev;
  return -device_not_connected;
}
int registerServers(void)
{
  FILE *fp = NULL;
  int i,cc=0,done=0;
  int name_col,id_col,id;
  char str[256],hdr[256],scratch[16],name[16];
  DEV *devlst;

  /* read local database for server names */

  if ((fp=fopen("srvlst.csv","rt")) == NULL) ccerr(no_such_file);
  for (done=0,i=0; fgets(str,255,fp) != NULL;) /* scan file       */
  {
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      strcpy(hdr,str);
      if ((name_col=findcol(hdr,"NAME")) < 0) ccerr(no_such_line);
      if ((id_col=findcol(hdr,"ID")) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }
    strncpy(name,colptr(name_col,str),16);
    strncpy(scratch,colptr(id_col,str),16);
    id = atoi(scratch);
    devlst = registerDevices(name,id);
    ArchiveServerList.Put(name,id,devlst);  // just a test
    if (NGdebug) cout << "registerServers: server " << name << " registered" << endl;
    i++;
  }
err:
  if (fp) fclose(fp);
  if (cc) cout << "registerServers: error " << cc << endl;
  return cc;
}
DEV *registerDevices(char *srvName,int idSrv)
{
  FILE *fp = NULL;
  int i,cc=0,done=0;
  int name_col,id_col,id;
  char str[256],hdr[256],scratch[16],name[16];
  DEV *dev,*devlst=NULL;

  sprintf(str,"%s.csv",srvName);
  if ((fp=fopen(str,"rt")) == NULL) ccerr(no_such_file);
  for (done=0,i=0; fgets(str,255,fp) != NULL;) /* scan file       */
  {
    if (strchr("%;#\n",str[0])) continue;      /* comment line(s) */
    if (!done)
    {
      strcpy(hdr,str);
      if ((name_col=findcol(hdr,"NAME")) < 0) ccerr(no_such_line);
      if ((id_col=findcol(hdr,"ID")) < 0) ccerr(no_such_line);
      done = 1;
      continue;
    }
    strncpy(name,colptr(name_col,str),16);
    strncpy(scratch,colptr(id_col,str),16);
    id = atoi(scratch);
    if ((dev=(DEV *)calloc(1,sizeof(DEV))) == NULL) ccerr(out_of_server_memory);
    strncpy(dev->devName.name,name,16);
    dev->idDev = idSrv*DEV_BOUND + id; // have a look at this later ...
    dev->Next = devlst;
    devlst = dev;
    if (NGdebug)
    {
      cout << "registerDevices: server " << srvName << " device ";
      cout << name << "(" << id << ") registered" << endl;
    }
    i++;
  }
err:
  if (fp) fclose(fp);
  if (cc) cout << "registerDevices: server " << srvName << " -> " << erlst[cc] << endl;
  return devlst;
}
EXPORTTAG int initEventServer(void)
{
  static int initialized = 0;

  if (initialized) return 0;
  registerStructs();
  registerServers();
  initialized = 1;
  return 0;
}
void evnini(void)
{
  initEventServer();
}

long TriggerEvent = 0;
EXPORTTAG void evntsk(void)
{
  if (TriggerEvent)
  {
    ArchiveEvent.Trigger(TriggerEvent);
    TriggerEvent = 0;
  }
  ArchiveServerList.Service();

  ArchiveEvent.debug = NGdebug;
  ArchiveServerList.debug = NGdebug;
}

EXPORTTAG int evneqm(char *devName,char *devProperty,DTYPE *dout,DTYPE *din,short access)
{
  char remSrvName[17],mode[4];
  NAME16 *name;
  AESnotify  *aesNotify;
  AEScontext *aesContext;
  int id,cc;
  ulong starttime,stoptime,evncode,evnnum;
  BYTE *tmpbuf;

  if (!strcmp(devProperty,"SET"))
  {
    if (!(access & CA_WRITE)) return illegal_read_write;
    if ( din->dFormat != CF_STRUCT ||
         strcmp(din->dTag,"AESNOT") ) return illegal_format;
    if (din->dArrayLength != 1) return dimension_error;
    aesNotify = (AESnotify *)din->data.vptr;
    strncpy(remSrvName,getClientName(),16);
    if (NGdebug)
      cout << "EVNEQM: received SET request from " << remSrvName << endl;
    // probably want to log this somewhere too !
    evnnum = ArchiveEvent.Set(0,aesNotify->eventCode,aesNotify->comment[0]);
    evnnum = time(NULL);
    if (dout->dFormat == CF_LONG && dout->dArrayLength > 0)
      *dout->data.lptr = evnnum;
    TriggerEvent = time(NULL);  // signal the background task
    return 0;
  }
  if (!strcmp(devProperty,"SETCOMMENT"))
  {
    if (!(access & CA_WRITE)) return illegal_read_write;
    if ( din->dFormat != CF_STRUCT ||
         strcmp(din->dTag,"AESNOT") ) return illegal_format;
    if (din->dArrayLength != 1) return dimension_error;
    aesNotify = (AESnotify *)din->data.vptr;
    strncpy(remSrvName,getClientName(),16);
    if (NGdebug)
      cout << "EVNEQM: received SET COMMENT request from " << remSrvName << endl;
    strcpy(mode,devName);
    ArchiveEvent.SetComment(aesNotify->eventNumber,aesNotify->comment[0],mode);
    return 0;
  }
  if (!strcmp(devProperty,"RECORD"))
  {
    if (!(access & CA_WRITE)) return illegal_read_write;
    if ( din->dFormat != CF_STRUCT ||
         strcmp(din->dTag,"AESCON") ) return illegal_format;
    if (din->dArrayLength != 1) return dimension_error;
    aesContext = (AEScontext *)din->data.vptr;
    strncpy(remSrvName,getClientName(),16);
    // probably want to log this somewhere too !
    if (NGdebug)
      cout << "EVNEQM: received RECORD request from " << remSrvName << endl;
    cc = ArchiveEvent.Record(aesContext->eventNumber,remSrvName,aesContext->deviceName);
    return cc;
  }
  if (!strcmp(devProperty,"REMOVE"))
  {
    if (!(access & CA_WRITE)) return illegal_read_write;
    if ( din->dFormat != CF_STRUCT ||
         strcmp(din->dTag,"AESCON") ) return illegal_format;
    if (din->dArrayLength != 1) return dimension_error;
    aesContext = (AEScontext *)din->data.vptr;
    strncpy(remSrvName,getClientName(),16);
    // probably want to log this somewhere too !
    if (NGdebug)
      cout << "EVNEQM: received REMOVE request from " << remSrvName << endl;
    return ArchiveEvent.Remove(aesContext->eventNumber,remSrvName,aesContext->deviceName);
  }
  if (!strcmp(devProperty,"NEVENTS"))
  {
    if (din->dFormat != CF_LONG) return illegal_format;
    if (dout->dFormat != CF_LONG) return illegal_format;
    if (dout->dArrayLength < 1) return illegal_read_write;
    evncode = 0;
    switch (din->dArrayLength)
    {
      case 3: evncode   = (din->data.lptr)[2];
      case 2: starttime = (din->data.lptr)[0];
              stoptime  = (din->data.lptr)[1];
              break;
      default: return illegal_read_write;
    }
    dout->data.lptr[0] = ArchiveEvent.queryNumEvents(starttime,stoptime);
    return 0;
  }
  if (!strcmp(devProperty,"EVENTS"))
  {
    if (din->dFormat != CF_LONG) return illegal_format;
    evncode = 0;
    switch (din->dArrayLength)
    {
      case 3: evncode   = (din->data.lptr)[2];
      case 2: starttime = (din->data.lptr)[0];
              stoptime  = (din->data.lptr)[1];
              break;
      default: return illegal_read_write;
    }
    switch (dout->dFormat)
    {
      case CF_LONG:
             ArchiveEvent.queryEvents(starttime,stoptime,evncode,dout->data.lptr,dout->dArrayLength);
             break;
      case CF_STRUCT:
           if (!strcmp(dout->dTag,"AES")) 
           {
             ArchiveEvent.queryEvents(starttime,stoptime,evncode,(AES *)dout->data.vptr,dout->dArrayLength);
             break;
           }
      default: return illegal_format;
    }
    return 0;
  }
  if (!strcmp(devProperty,"NASERVERS"))
  {
    if (dout->dArrayLength)
    {
      switch (dout->dFormat)
      {
        case CF_SHORT: dout->data.sptr[0] = (short)ArchiveServerList.queryNumServers();
                       break;
        case CF_LONG: dout->data.lptr[0] = ArchiveServerList.queryNumServers();
                       break;
        default: return illegal_format;
      }
      return 0;
    }
    return illegal_read_write;
  }
  if (!strcmp(devProperty,"ASERVERS"))
  {
    if (dout->dFormat != CF_CHAR16) return illegal_format;
    if (!strcmp(devName,"ALL") || !strcmp(devName,"#-1"))
      ArchiveServerList.queryServerNames((NAME16 *)dout->data.vptr,dout->dArrayLength);
    else if (devName[0] == '#')
    {
      char scratch[16];
      strncpy(scratch,&devName[1],15); scratch[15] = 0;
      id = atoi(scratch);
      if ((name=ArchiveServerList.queryServerName(id)) != NULL)
        memcpy(dout->data.vptr,name->name,16);
    }
    else return illegal_equipment_number;
    return 0;
  }
  if (!strcmp(devProperty,"NDSERVERS"))
  {
    int nds;
    if (!strcmp(devName,"ALL") || !strcmp(devName,"#-1"))
      nds = ArchiveServerList.queryNumDeviceServers();
    else if (devName[0] == '#')
    {
      int iddev = atoi((char *)&devName[1]);
      nds = ArchiveServerList.queryNumDeviceServers(iddev);
    }
    else
      nds = ArchiveServerList.queryNumDeviceServers((NAME16 *)devName);

    if (dout->dArrayLength)
    {
      switch (dout->dFormat)
      {
        case CF_SHORT: dout->data.sptr[0] = (short)nds;
                       break;
        case CF_LONG: dout->data.lptr[0] = nds;
                       break;
        default: return illegal_format;
      }
      return 0;
    }
    return illegal_read_write;
  }
  if (!strcmp(devProperty,"DSERVERS"))
  {
    if (dout->dFormat != CF_CHAR16) return illegal_format;
    if (!strcmp(devName,"ALL") || !strcmp(devName,"#-1"))
      ArchiveServerList.queryDeviceNames((NAME16 *)dout->data.vptr,dout->dArrayLength);
    else if (devName[0] == '#')
    {
      char scratch[16];
      strncpy(scratch,&devName[1],15); scratch[15] = 0;
      id = atoi(scratch);
      if ((name=ArchiveServerList.queryDeviceName(id)) != NULL)
        memcpy(dout->data.vptr,name->name,16);
    }
    else 
    {
      ArchiveServerList.queryDeviceNames((NAME16 *)dout->data.vptr,(NAME16 *)devName,dout->dArrayLength);
    }
    return 0;
  }
  return illegal_property;
}
EXPORTTAG void PostSystemInit(void)
{
  RegisterEquipmentModule(NULL,"EVNEQM",0,evneqm,evnini,evntsk,100,NULL);
  RegisterDeviceName("EVNEQM","ALL",0);
}

