// this code fills in the methods from srvlst.h
// it is under development and should not be touched

#include "project.def"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "errors.h"
#include "eventlst.h"
#include "srvlst.h"
#ifdef CSOURCE
# define EXPORTTAG extern "C"
#else
# define EXPORTTAG extern
#endif
EXPORTTAG {
#include "rpctypes.h"
}

int ServerList::Put(char *srvName,int id)
{
  return Put(srvName,id,NULL);
}
int ServerList::Put(char *srvName,int id,DEV *devlst)
{
  SRV *srv;

  if (srvName == NULL || strlen(srvName) == 0) return -1;
  for (srv=gSRVlist; srv; srv = srv->Next)
  {
    if (!strncmp(srvName,srv->srvName.name,16))
    {
      if (devlst != NULL) srv->devlst = devlst;
      if (id != srv->idSrv)
      {
        cout << srvName << " id changed: " << srv->idSrv << " to " << id << endl;
        srv->idSrv = id;
      }
      return srv->idSrv;
    }
  }
  if ((srv=(SRV *)calloc(1,sizeof(SRV))) == NULL) return -1;
  strncpy(srv->srvName.name,srvName,16);
  if (devlst != NULL) srv->devlst = devlst;
  srv->Next = gSRVlist;
  srv->idSrv = id;
  gSRVlist  = srv;
  nServers++;
  if (debug) cout << "added " << srvName << " to server list (" << nServers << " total)" << endl;
  return srv->idSrv;
}
int ServerList::Put(char *srvName)
{
  return Put(srvName,(DEV *)NULL);
}
int ServerList::Find(char *srvName)
{
  return Put(srvName,(DEV *)NULL);
}
SRV *ServerList::getSRVfromName(char *srvName)
{
  SRV *srv;

  for (srv=gSRVlist; srv; srv = srv->Next)
  {
    if (!strcmp(srvName,srv->srvName.name)) break;
  }
  return srv;
}
int ServerList::getSRVidfromName(char *srvName)
{
  SRV *srv;

  for (srv=gSRVlist; srv; srv = srv->Next)
  {
    if (!strcmp(srvName,srv->srvName.name)) return srv->idSrv;
  }
  return -1;
}

SRV *ServerList::Find(int idSrv)
{
  SRV *srv;

  for (srv=gSRVlist; srv; srv = srv->Next)
  {
    if (srv->idSrv == idSrv) return srv;
  }
  return srv;
}

int ServerList::Put(char *srvName, DEV *devlst)
{
  SRV *srv;
  int i;

  if (srvName == NULL || strlen(srvName) == 0) return -1;
  for (srv=gSRVlist,i=0; srv; srv = srv->Next)
  {
    if (srv->idSrv > i) i = srv->idSrv;
    if (!strncmp(srvName,srv->srvName.name,16))
    {
      if (devlst != NULL) srv->devlst = devlst;
      return srv->idSrv;
    }
  }
  if ((srv=(SRV *)calloc(1,sizeof(SRV))) == NULL) return -1;
  strncpy(srv->srvName.name,srvName,16);
  if (devlst != NULL) srv->devlst = devlst;
  srv->Next = gSRVlist;
  srv->idSrv = i;
  gSRVlist  = srv;
  nServers++;
  if (debug) cout << "added " << srvName << " to server list (" << nServers << " total)" << endl;
  return srv->idSrv;
}

int ServerList::Remove(char *srvName)
{
  SRV *srv, *srvPrev = gSRVlist;

  for (srv=gSRVlist; srv; srv = srv->Next)
  {
    if (!strncmp(srvName,srv->srvName.name,16))
    {
      if (srv->devlst != NULL) free(srv->devlst);
      if (srv != gSRVlist) srvPrev->Next = srv->Next;
      else gSRVlist = srv->Next;
      free(srv);
      nServers--;
      return 0;
    }
    srvPrev = srv;
  }
  return non_existent;
}

int ServerList::Remove(int idSrv)
{
  SRV *srv, *srvPrev = gSRVlist;
  int i;

  for (srv=gSRVlist,i=0; srv; srv = srv->Next,i++)
  {
    if (idSrv == i)
    {
      if (srv->devlst != NULL) free(srv->devlst);
      if (i != 0) srvPrev->Next = srv->Next;
      else gSRVlist = srv->Next;
      free(srv);
      nServers--;
      return 0;
    }
    srvPrev = srv;
  }
  return non_existent;
}
void ExternalSendCallback(int id,int cc)
{
  ArchiveServerList.SendAcknowledged(id,cc);
}
void ServerList::SendAcknowledged(int id,int cc)
{
  SRV *srv;
  MSG *msg;
  ulong nextTimestamp = 0;

  for (srv=gSRVlist; srv != NULL; srv=srv->Next)
  {
    if (srv->callbackID == id) // got it
    {
      srv->nLastNotifyAttempts++;
      if (cc == 0) srv->lastAcknowledgedCallback = time(NULL);
      else if (srv->nLastNotifyAttempts < NRETRY) return;
      for (msg=gMSGlist; msg != NULL ; msg=msg->Next)
      {
        if (msg->msgTimestamp == srv->lastMSGTimestamp)
        {
          if (debug)
          {
            cout << "Callback: " << srv->srvName.name << " accounted for; ";
            cout << " completion code: " << cc;
            cout << " next message timestamp: " << nextTimestamp << endl;
          }
          if (++msg->srvCount == nServers) rmvMSG(msg->msgTimestamp);
          srv->lastMSGTimestamp = nextTimestamp;
          srv->nLastNotifyAttempts = 0;
          srv->CurrentNotifyAttempt = 0;
          break;
        }
        else nextTimestamp = msg->msgTimestamp;
      }
      return;
    }
  }
}
void ServerList::Service(void)
{
  SRV *srv;

  for (srv=gSRVlist; srv != NULL; srv=srv->Next)
  {
    if (srv->nLastNotifyAttempts > srv->CurrentNotifyAttempt &&
        srv->lastMSGTimestamp > srv->lastAcknowledgedCallback)
    {
      srv->CurrentNotifyAttempt = srv->nLastNotifyAttempts;
      if (debug)
      {
        cout << "Service: " << srv->srvName.name << " Attempts: ";
        cout << srv->CurrentNotifyAttempt << " vs ";
        cout << srv->nLastNotifyAttempts << " times: ";
        cout << srv->lastMSGTimestamp << " vs ";
        cout << srv->lastAcknowledgedCallback << endl;
      }
      Send(srv);
    }
  }
  return;
}

int ServerList::Send(char *property,BYTE *buffer,int buflen)
{
  NAME16 p;
  memset(&p,0,sizeof(NAME16)); strncpy(p.name,property,16);
  return Send((SRV *)NULL,&p,buffer,buflen);
}
int ServerList::Send(SRV *srv)
{
  MSG *msg;
  if (srv == NULL) return non_existent;

  for (msg=gMSGlist; msg != NULL; msg=msg->Next)
  {
    if (msg->msgTimestamp == srv->lastMSGTimestamp)
    {
      if (debug) cout << "Re-Send " << msg->property.name << endl;
      return Send(srv,&msg->property,msg->buffer,msg->bufferlength);
    }
  }
  return non_existent;
}
int ServerList::Send(SRV *srvEntry,NAME16 *property,BYTE *buffer,int buflen)
{
  MSG *msg;
  SRV *srv,*srvStart=gSRVlist,*srvStop=NULL;
  DTYPE dout,din;

  if (srvEntry != NULL)        // target one server
  {
    srvStart = srvEntry;
    srvStop  = srvStart->Next;
  }
  msg = addMSG(property,buffer,buflen);
  for (srv=srvStart; srv != srvStop; srv = srv->Next)
  {
    if (debug) cout << "send trigger to " << srv->srvName.name << endl;
    if (srv->msgBufferlength != buflen)
    {
      if (srv->msgBuffer != NULL) free(srv->msgBuffer);
      if ((srv->msgBuffer=(BYTE *)calloc(1,buflen)) == NULL) quit("out of memory");
    }
    memcpy(srv->msgBuffer,buffer,buflen);
    dout.dFormat = CF_STRUCT;
    strcpy(dout.dTag,"AESNOT");
    dout.dArrayLength = 1;
    dout.data.vptr = srv->msgBuffer;
    din.dFormat = CF_STRUCT;
    strcpy(din.dTag,"AESNOT");
    din.dArrayLength = 1;
    din.data.vptr = srv->msgBuffer;
    if ((srv->callbackID=AttachLink(srv->srvName.name,property->name,NULL,&din,CA_WRITE,1000,ExternalSendCallback,CM_SINGLE)) < 0)
    {
      rmvMSG(msg->msgTimestamp);
      return -srv->callbackID;
    }
    if (srv->lastMSGTimestamp == 0) // ready for new message
    {
      srv->lastMSGTimestamp = msg->msgTimestamp;
      srv->nLastNotifyAttempts = 0;
      srv->CurrentNotifyAttempt = 0;
    }
  }
  return 0;
}
int ServerList::Send(SRV *srvEntry,NAME16 *property,AESnotify *aesnot)
{
  MSG *msg;
  SRV *srv,*srvStart=gSRVlist,*srvStop=NULL;
  DTYPE dout,din;

  if (srvEntry != NULL)        // target one server
  {
    srvStart = srvEntry;
    srvStop  = srvStart->Next;
  }
  msg = addMSG(property,(BYTE *)aesnot,sizeof(AESnotify));
  for (srv=srvStart; srv != srvStop; srv = srv->Next)
  {
    if (debug) cout << "send trigger to " << srv->srvName.name << endl;
    if (srv->msgBufferlength != sizeof(AESnotify))
    {
      if (srv->msgBuffer != NULL) free(srv->msgBuffer);
      if ((srv->msgBuffer=(BYTE *)calloc(1,sizeof(AESnotify))) == NULL) quit("out of memory");
    }
    memcpy(srv->msgBuffer,aesnot,sizeof(AESnotify));
    dout.dFormat = CF_STRUCT;
    strcpy(dout.dTag,"AESNOT");
    dout.dArrayLength = 1;
    dout.data.vptr = srv->msgBuffer;
    din.dFormat = CF_STRUCT;
    strcpy(din.dTag,"AESNOT");
    din.dArrayLength = 1;
    din.data.vptr = srv->msgBuffer;
    if ((srv->callbackID=AttachLink(srv->srvName.name,property->name,NULL,&din,CA_WRITE,1000,ExternalSendCallback,CM_SINGLE)) < 0)
    {
      rmvMSG(msg->msgTimestamp);
//      return -srv->callbackID;
    }
    if (srv->lastMSGTimestamp == 0) // ready for new message
    {
      srv->lastMSGTimestamp = msg->msgTimestamp;
      srv->nLastNotifyAttempts = 0;
      srv->CurrentNotifyAttempt = 0;
    }
  }
  return 0;
}
// method currently not implemented...
// the evneqm.cpp module handles the incoming RPCs directly
// later it can funnel them through this method...
int ServerList::Recv(int idSrv,char *property,BYTE *buffer,int buflen)
{
  if (!strcmp(property,"SET"))
  {
    AESnotify aesBuffer;
    memcpy(&aesBuffer,buffer,MIN(sizeof(AESnotify),buflen));
//    return ArchiveEvent.Set(idSrv,aesBuffer.eventCode,aesBuffer.comment[64]);
    return 0;
  }
  if (!strcmp(property,"RECORD"))
  {
    AEScontext aesBuffer;
    memcpy(&aesBuffer,buffer,MIN(sizeof(AEScontext),buflen));
//    return ArchiveEvent.Record(aesBuffer.eventNumber,aesBuffer.idDev);
    return 0;
  }
  if (!strcmp(property,"REMOVE"))
  {
    AEScontext aesBuffer;
    memcpy(&aesBuffer,buffer,MIN(sizeof(AEScontext),buflen));
//    return ArchiveEvent.Remove(aesBuffer.eventNumber,aesBuffer.idDev);
    return 0;
  }
  return illegal_property;
}
ServerList::ServerList(void)
{
  gSRVlist = NULL;
  nServers = 0;
  gMSGlist = NULL;
  debug    = 0;
}
MSG *ServerList::addMSG(NAME16 *property,BYTE *buffer,int bufferlength)
{
  MSG *msg;

  for (msg=gMSGlist; msg != NULL; msg=msg->Next)
  {
    if (!memcmp(&msg->property,property,sizeof(NAME16)) &&
         msg->bufferlength == bufferlength              &&
        !memcmp(msg->buffer,buffer,bufferlength)           )
    {
      if (debug) cout << "found message " << property->name << endl;
      return msg;
    }
  }
  if ((msg=(MSG *)calloc(1,sizeof(MSG))) == NULL) quit("out of memory");
  memcpy(&msg->property,property,sizeof(NAME16));
  if ((msg->buffer=(BYTE *)calloc(1,bufferlength)) == NULL) quit("out of memory");
  memcpy(msg->buffer,buffer,bufferlength);
  msg->bufferlength = bufferlength;
  msg->msgTimestamp = time(NULL);
  msg->srvCount = 0;
  msg->Next = gMSGlist;
  return gMSGlist = msg;
}
void ServerList::rmvMSG(ulong msgTimestamp)
{
  MSG *msg,*msg0;

  for (msg0=msg=gMSGlist; msg != NULL; msg0=msg, msg=msg->Next)
  {
    if (msg->msgTimestamp == msgTimestamp)
    {
      if (msg0 == msg) gMSGlist = msg->Next;
      else msg0->Next = msg->Next;
      if (debug)
      {
        cout << "remove message " << msg->property.name << " at ";
        cout << msg->msgTimestamp << "; list at " << gMSGlist << endl;
      }
      free(msg->buffer);
      free(msg);
      return;
    }
  }
}
// caller supplies srvNames buffer :
int ServerList::queryServerNames(NAME16 *srvNames, int num)
{
  SRV *srv;

  memset(srvNames,0,sizeof(NAME16)*num);
  for (srv=gSRVlist; srv != NULL; srv=srv->Next)
  {
    if (srv->idSrv < num)
      strncpy(srvNames[srv->idSrv].name,srv->srvName.name,sizeof(NAME16));
  }
  return nServers;
}
NAME16 *ServerList::queryServerName(int idSrv)
{
  SRV *srv=Find(idSrv);
  return srv == NULL ? (NAME16 *)NULL : &srv->srvName;
}
int ServerList::queryNumDeviceServers(int idSrv)
{
  SRV *srv;
  DEV *dev;
  int n=0;

  if (idSrv < 0 || idSrv > MAXSRV)
  {
    if (debug) cout << "Server ID out of range : " << idSrv << endl;
    return 0;
  }
  for (srv=gSRVlist; srv != NULL; srv=srv->Next)
  {
    if (srv->idSrv == idSrv)
    {
      for (dev=srv->devlst; dev != NULL; dev=dev->Next, n++);
      break;
    }
  }
  return n;
}
int ServerList::queryNumDeviceServers(NAME16 *srvName)
{
  int idSrv = Find(srvName->name);
  return queryNumDeviceServers(idSrv);
}
int ServerList::queryNumDeviceServers(void)
{
  SRV *srv;
  int n = 0;
  for (srv=gSRVlist; srv != NULL; srv=srv->Next)
    n += queryNumDeviceServers(srv->idSrv);
  return n;
}

int ServerList::queryDeviceNames(int idSrv,NAME16 *devNames, int num)
{
  SRV *srv=Find(idSrv);
  DEV *dev;
  int n=0, id;

  if (srv == NULL) return 0;
  for (dev=srv->devlst; dev != NULL; dev=dev->Next, n++)
  {
    if ((id=dev->idDev-idSrv*DEV_BOUND) < num)
      strncpy(devNames[id].name,dev->devName.name,sizeof(NAME16));
  }
  return n;
}
int ServerList::queryDeviceNames(NAME16 *devNames, NAME16 *srvName, int num)
{
  SRV *srv=getSRVfromName(srvName->name);
  int idSrv;
  DEV *dev;
  int n=0, id;

  if (srv == NULL) return 0;
  idSrv = srv->idSrv;
  for (dev=srv->devlst; dev != NULL; dev=dev->Next, n++)
  {
    if ((id=dev->idDev-idSrv*DEV_BOUND) < num)
      strncpy(devNames[id].name,dev->devName.name,sizeof(NAME16));
  }
  return n;
}
int ServerList::queryDeviceNames(NAME16 *devNames, int num)
{
  SRV *srv;
  int n = 0;
  if (devNames == NULL) return 0;
  memset(devNames,0,sizeof(NAME16)*num);
  for (srv=gSRVlist; srv != NULL; srv=srv->Next)
  {
    if (num < n + DEV_BOUND) break;
    n += queryDeviceNames(srv->idSrv,&devNames[srv->idSrv*DEV_BOUND],DEV_BOUND);
  }
  return n;
}
NAME16 *ServerList::queryDeviceName(int idSrv, int idDev)
{
  SRV *srv=Find(idSrv);
  DEV *dev;

  if (srv == NULL) return (NAME16 *)0;
  for (dev=srv->devlst; dev != NULL; dev=dev->Next)
  {
    if (idDev == dev->idDev) return &dev->devName;
  }
  return (NAME16 *)0;
}
NAME16 *ServerList::queryDeviceName(int idDev)
{
  SRV *srv;
  DEV *dev;
  NAME16 *name = (NAME16 *)NULL;

  for (srv=gSRVlist; srv != NULL; srv=srv->Next)
    if ((name=queryDeviceName(srv->idSrv,idDev)) != NULL) break;
  return name;
}

