// this header file should NOT be edited

#ifndef SRVLST_H_
#define SRVLST_H_

#include <iostream.h>
#include <fstream.h>
#include <ctype.h>
#if defined(__cplusplus) && !defined(FORCE_CPP)
# define EXPORTTAG extern "C"
#else
# define EXPORTTAG extern
#endif
# include "rpctypes.h"
//#include "evnttype.h"

#define DEV_BOUND 16
#define NRETRY 2
#define MAXSRV 32

typedef struct DEVtag
{
  NAME16 devName;
  int    idDev;
  struct DEVtag *Next;
} DEV;

typedef struct MSGtag
{
  NAME16 property;
  BYTE   *buffer;
  int    bufferlength;
  ulong  msgTimestamp;
  int    srvCount;
  struct MSGtag *Next;
} MSG;

typedef struct SRVtag
{
  NAME16 srvName;
  DEV   *devlst;
  int    idSrv;
  int    callbackID;
  int    nLastNotifyAttempts;
  int    CurrentNotifyAttempt;
  ulong  lastMSGTimestamp;
  ulong  lastAcknowledgedCallback;
  BYTE   *msgBuffer;
  int    msgBufferlength;
  struct SRVtag *Next;
} SRV;

class ServerList
{
  SRV *gSRVlist;
  int Find(char *srvName);
  SRV *Find(int idSrv);
  int nServers;
  MSG *gMSGlist;
  MSG *addMSG(NAME16 *property,BYTE *buffer,int bufferlength);
  void rmvMSG(ulong msgTimestamp);
public:
  int debug;
  int getSRVidfromName(char *srvName);
  SRV *getSRVfromName(char *srvName);
  ServerList();
  int Put(char *srvName,int id);
  int Put(char *srvName, int id, DEV *devlst);
  int Put(char *srvName);
  int Put(char *srvName, DEV *devlst);
  int Remove(char *srvName);
  int Remove(int idSrv);
  void Service(void);
  int Send(SRV *srv);
  int Send(char *property,BYTE *buffer,int buflen);
  int Send(SRV *srvEntry,NAME16 *property,BYTE *buffer,int buflen);
  int Send(SRV *srvEntry,NAME16 *property,AESnotify *aesnot);
  void SendAcknowledged(int id,int cc);
  int Recv(int idSrv,char *property,BYTE *buffer,int buflen);
  int queryNumServers(void) { return nServers; }
  int queryServerNames(NAME16 *srvNames, int num);
  NAME16 *queryServerName(int id);
  int queryNumDeviceServers(void);
  int queryNumDeviceServers(int id);
  int queryNumDeviceServers(NAME16 *srvName);
  int queryDeviceNames(int idSrv,NAME16 *devNames, int num);
  int queryDeviceNames(NAME16 *devNames, NAME16 *srvName, int num);
  int queryDeviceNames(NAME16 *devNames, int num);
  NAME16 *queryDeviceName(int idSrv, int idDev);
  NAME16 *queryDeviceName(int idDev);
  void quit(char *txt);
  int error(char *txt);
};

inline void ServerList::quit(char *txt)
{
  cout << "progam terminating: " << txt << endl;
  exit(1);
}
inline int ServerList::error(char *txt)
{
  if (debug) cout << "error: " << txt << endl;
  return -1;
}


extern ServerList ArchiveServerList;

#endif // SRVLST_H_

