/*
 * devsrv    REVISION HISTORY:
 * Generated by SRVWIZARD on Tue Jun  3 21:21:42 2003
*/

#include "app_version.h"
#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "errors.h"
#include "rpctypes.h"
#include "history.h"
#include "swaplib.h"
#include "almsrv.h"
#include "toolkit.h"
#include "stseqm.h"

int SimulateData(int start,int range)
{
  /* This routine is useful for test servers  */
  return start + rand()%(range);
}

char *SimulateStringData(int length)
{
  static char lclStringBuffer[512];
  time_t t = time(NULL);
  static int counter = 1;
  /* This routine is useful for test servers  */
  sprintf(lclStringBuffer,"%d : Simulated String generated %s",counter++,ctime(&t));
  if (length < 0) length = 0;
  if (length < 512) lclStringBuffer[length] = 0;
  return lclStringBuffer;
}

void PreSystemInit(void)
{
  /* Some System Parameters and their default values    */
  /* are shown below.  You may change them as necessary */
  MinPollingRate = 1000;
  MaxPollingRate = 30000;
  MaxNumContracts = 300;
  MaxNumClients = 50;
  MaxNumConnections = 300;
  FeclogDepth = 500;
  StartupDebug = TRUE;
  RequireAcknowledgments = TRUE;
  MaxRPCTransportSize = 65535;
  gRetardSingleContractRemoval = FALSE;
  useMonthlyHistoryFiles = TRUE;
  AssignFecApplicationInfo(APPV_MAJOR,APPV_MINOR,APPV_REVISION);

  /* If you plan to use FEC Name registration via API call rather than          */
  /* the fecid.csv startup file, then uncomment the following line              */
  /*

  RegisterFecNameEx("TESTSERVER.0","duval's Test FEC","UNIX","duval's office","none","duval",0,"TEST");

  */

}

void PostSystemInit(void)
{
  /* register equipment modules here:                                           */
  RegisterEquipmentModule(NULL,STSEQM_TAG,0,stseqm,stseqm_ini,stseqm_bkg,STSEQM_RATE,stseqm_exi);

  /* Alternative:  you can forgo the 'exports.csv' file by registering all      */
  /* properties via API call and supplying the exported device server name as   */
  /*
  RegisterEquipmentModule("HEFECSTATS",STSEQM_TAG,0,stseqm,stseqm_ini,stseqm_bkg,STSEQM_RATE,stseqm_exi);
  */
  /* TODO: add any remaining general initialization code here                   */
}
int main(int argc, char *argv[])
{
  int cc;
  /* TODO: modify command line input to suit your own needs. */
  /* Here: the debug level is set according to initial input */
  switch (argc)
  {
    case 2:
      NGdebug = atoi(argv[1]);
      break;
    default:
      NGdebug = 0;
  }
  /* To deviate from default settings, initialize */
  /* any system variables in PreSystemInit() */

  PreSystemInit();

  /* initialize RPC server: */

  if ((cc=SystemInit(TRUE)) != 0)
  {
    printf(erlst[cc]);
    exit(1);
  }

  /* Make all other registrations in PostSystemInit() */

  PostSystemInit();

  for(;;)
  {
    /* TODO: add any additional non-TINE processing here */
    /*       being careful not to block operations */

    SystemCycle(TRUE);
  }
  return 0;
}
