// =============================================================
// ==
// ==   Database consistency check routine: checkdb.c
// ==
// =============================================================
#include "stdlib.h"
#include "math.h"
#include <string.h>
#include <time.h>
#include <errno.h>
#include <stdio.h>
#include <fcntl.h>
#include <malloc.h>
#include <ctype.h>
#include <signal.h>
#include "archive.h"
#include "rpctypes.h"
#include "database.h"
#include "errors.h"

FEC *fec;
int  nfecs, nparam;
int archPending = 0;
int getNrActiveFecs(char *fname);
void getFecInfo(void);
int wrtFlg,archdebug=0;
char cbuff[NETMEX_BUF_SIZE];
int totalNrFECs = 0;
int g_isTerminating = 0;

#define WRITE     -1
#define READ       1
#define MAXFILES   100

#define logerr(txt) { perror("open"); strcpy(s,txt); goto error; }
#define ccerr(i) { cc = i; goto err; }

//============= General PKTR archiving globals ===========================

FILE *wfp, *rfp;
int Hwfp;

char sbuf[20];
char timebuf[9], datebuf[9];

int fileNo = 0;
void AppendArchiveLog(char *str) { return; }
void dumpFecs(void)
{
  int i,j;
  
  for (i=0; i<nfecs; i++)
  {
    printf("%d: %s %s %s %d %d\n",i,fec[i].eqm,fec[i].property,fec[i].devname,
           fec[i].len,fec[i].reclen);
    for (j=0; j<fec[i].nparam; j++)
      printf("\t%s %d %d\n",fec[i].fecdata[j].param,fec[i].fecdata[j].format,fec[i].fecdata[j].size);
  }
}
int dbInit(char *dbfile)
{
  int i, cc=0;

  totalNrFECs = getNrActiveFecs(dbfile);

  if ((fec=(FEC *)calloc(totalNrFECs,sizeof(FEC))) == NULL) ccerr(out_of_server_memory);
if ((subSystems=(SUB_SYS *)calloc(totalNrFECs,sizeof(SUB_SYS))) == NULL) ccerr(out_of_server_memory);
if ((prpAlias=(PRP_ALIAS *)calloc(totalNrFECs,sizeof(PRP_ALIAS))) ==
NULL) ccerr(out_of_server_memory);

  nfecs=archLoad(dbfile,0);    // number of fecs being archived
  nparam=paramLoad(nfecs,0);    // number of parameters archived
  dumpFecs();
err:
  if (cc) printf("Init error: %s",erlst[cc]);
  return cc;
}
int main(int argc,char *argv[])
{
  char fn[64];
  switch ( argc )
  {
    case 2: 
     strncpy(fn,argv[1],64);
     if (strstr(fn,".csv") == NULL) strcat(fn,".csv");
     dbInit(fn); break;
    default: printf("Usage: checkdb <database file>\n"); break;
  }
  return 0;
}

