# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI,OSF CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl

INCL = /usr/include/tine
LIBS = /usr/lib
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h \
	${INCL}/rpctypes.h \
	${INCL}/rpcdefs.h \
	${INCL}/almsrv.h

CC = g++ -c -g -I${INCL}
CC = cc -c -g -I${INCL}
CCL = cc -g
LM = -lm

rpcserv: setbuildinfo rpcserv.o statebase.o filer.o archbase.o archlib.o ${LIBS}/libtine.a
	${CCL} -o rpcserv rpcserv.o statebase.o filer.o archbase.o archlib.o ${LIBS}/libtine.a ${LM}
	chmod a+s rpcserv

rpcserv.o: rpcserv.c app_version.h ${HDRS}
	${CC} rpcserv.c

statebase.o: statebase.c archive.h ${HDRS}
	${CC} statebase.c 

filer.o: filer.c archive.h ${HDRS}
	${CC} filer.c 

archbase.o: archbase.c archive.h ${HDRS}
	${CC} archbase.c 

archlib.o: archlib.c archive.h ${HDRS}
	${CC} archlib.c 

setbuildinfo:
	./set-build-info

clean:
	rm *.o
