#ifndef _STATEBASE_H_
#define _STATEBASE_H_

#define NULLSTATE_NAME "NullStates.csv"
#define BEAMPARAM_NAME "BeamParameters.csv"
#define STATEPARAM_NAME "StateParameters.csv"
#define EPROC_NAME "eDeclaredProcedures.csv"
#define PPROC_NAME "pDeclaredProcedures.csv"
#define STATESRV_NAME "StateServer.csv"

#define CHK_VALID_MIN 0x01
#define CHK_VALID_MAX 0x02
typedef struct
{
  char name[16];
  char beamtype[16];
  int  fmt;
  void *ptr;
  int fecindex;
  int typeindex;
  float minValid;
  float maxValid;
  int chkValid;
} CHECKNAME;

extern int p_stateindex;
extern int e_stateindex;

extern char gTargetStateServer[64];

typedef struct
{
  char typestr[32];
  char procstr[32];
  char trigstr[32];
} DECLPROC;

extern DECLPROC *eDeclaredProcedures;
extern int nEDeclaredProcedures;
extern DECLPROC *pDeclaredProcedures;
extern int nPDeclaredProcedures;

extern CHECKNAME *checkedParameters;
extern int nCheckedParameters;
extern CHECKNAME *checkedStates;
extern int nCheckedStates;

#endif /* _STATEBASE_H_ */

