#include "rpctypes.h"

#ifndef BYTE
# define BYTE unsigned char
#endif

#define MARCHSRV_EVENTCODE 0x1000
#undef POLL

#define READ     0x01
#define WRITE    0x02
#define POLL     0x04
#define WAIT     0x08
#define SETNUM   0x10
#define PREALLOC 0x20
#define FORWARD  0x40

#define PREALLOCSIZE 0x20000

typedef struct DAStag
{
  char tag[16];
  char prp[32];
  char dev[64];
  char tagArc[16];
  char prpArc[32];
  short EqpNoStart;
  short EqpNoStop;
  DTYPE dout;
  DTYPE din;
  BYTE *dinlock;
  short acc;
  short wait;
  short timeout;
  short value;
  short askRemote;
  short reserved;
  float scale;
  float shift;
  int ndev; 
  int numberToAcquire;
  NAME16 *devlst;
  NAME16 *devAliasLst;
  int nprpAlias;
  NAME32 *prpAliasLst;
} DAS;       /* Data Access Structure */

typedef struct ARBtag
{
  char src[80];
  char dst[80];
  char hdr[80];
  char server[16];
  char name[16];
  char ext[16];
  char fwdsrv[64];
  char fwdprp[32];
  int  fwddata;
  FILE *fp;
  int  step;
  int  nsteps;
  int  depthInMonths;
  time_t interim;
  time_t start;
  time_t eventtime;
  time_t tot;       /* time of trigger */
  int  resultPending;
  int  recordEvents;
  int  recordPending;
  int  aborted;
  DAS  *das;
} ARB;       /* Archive Reference Block */

extern ARB *arb;
extern nARB;

#define ARCHIVE_LIST_FILE "pmArchiveList.csv"
#define stdArchiveDirectory "../CACHE"
extern char *archiveListFile;

char *GetStoredDeviceName(int devnr, char *tag);
char *GetStoredDeviceNameEx(char *context,int devnr, char *tag);
int   GetStoredDeviceNumber(NAME16 *devnam, char *tag);
int   GetStoredDeviceNumberEx(char *context,NAME16 *devnam, char *tag);
char *GetStoredDeviceNameFromAlias(char *alias,char *tagname);
char *GetStoredDeviceNameFromAliasEx(char *context,char *alias,char *tagname);
char *GetStoredPropertyFromAlias(char *tagname,char *alias);
char *GetStoredPropertyFromAliasEx(char *context,char *tagname,char *alias);
void AppendArchiveLog(char *str);
