// do NOT remove functionality from this header file
// it's okay to add methods

#ifndef EVENTLST_H_
#define EVENTLST_H_

#include <iostream.h>
#include <fstream.h>
#include <ctype.h>
#include "evnttype.h"

#define EVENTLST_VERSION 1

typedef struct
{
  ulong version;
  ulong eventNumber;
  ulong eventCode;
  ulong reserved;
  char comment[4][64];
} AESnotify;

typedef struct
{
  ulong version;
  ulong eventNumber;
  ulong eventCode;
  ulong reserved;
  char  deviceName[16];
} AEScontext;

// define the explicit INTEL structure size for 1-byte alignment
#define AESnotifyStructSize ((sizeof(ulong)*1) +\
                             (sizeof(ulong)*1) +\
                             (sizeof(ulong)*1) +\
                             (sizeof(ulong)*1) +\
                              4*64)

// define the explicit INTEL structure size for 1-byte alignment
#define AEScontextStructSize ((sizeof(ulong)*1) +\
                              (sizeof(ulong)*1) +\
                              (sizeof(ulong)*1) +\
                              (sizeof(ulong)*1) +\
                               16)

typedef struct AEStag
{
  ulong eventNumber;
  ulong eventCode;
  char comment[4][64];
  BYTE dsMask[32];
} AES;

// define the explicit INTEL structure size for 1-byte alignment
#define AESStructSize ((sizeof(ulong)*1) +\
                       (sizeof(ulong)*1) +\
                       (4*64) +\
                       (32))

class EventList
{
  int nEvents;
//  ifstream elin;
  char  elfn[80];
  long  Find(ulong eventNumber);
  long  Find(ulong eventNumber,AES &aes);
  long  Locate(ulong &eventNumber,int &yr,int &mn);
  long  Locate(ulong &eventNumber,int &yr,int &mn,int precision);
public:
  int   debug;
  EventList();
  ulong Set(int idSource, int eventCode, char *comment);
  int   SetComment(int eventNumber,char *comment, char *mode);
  int   Trigger(long eventNumber);
  int   Record(long eventNumber,char *strArchiveServer,char *strDeviceServer);
  int   Record(long eventNumber, int idDeviceServer);
  int   Remove(long eventNumber,char *strArchiveServer,char *strDeviceServer);
  int   Remove(long eventNumber, int idDeviceServer);
  int   queryNumEvents(void) { return nEvents; }
  int   queryNumEvents(ulong starttime, ulong stoptime);
  int   queryNumEvents(ulong starttime, ulong stoptime, ulong evncode);
  int   queryEvents(ulong starttime, ulong stoptime,AES *aes,int num);
  int   queryEvents(ulong starttime, ulong stoptime,ulong evncode,AES *aes,int num);
  void  quit(char *txt);
  int   error(char *txt);
};

inline void EventList::quit(char *txt)
{
  cout << "progam terminating: " << txt << endl;
  exit(1);
}
inline int EventList::error(char *txt)
{
  if (debug) cout << "error: " << txt << endl;
  return -1;
}

#define MAKECODE(id,cd) (((id)<<16)|(cd))
#define BITSinBYTE 8
#define EVENT_IGNORE 0xffffffff

extern EventList ArchiveEvent;

#endif // EVENTLST_H_

