# Makefile for client test program - PKTR rpc calls
# Version 20.03.95
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI     CC = cc         CCL = cc         LM = -lm
# OSF     CC = cc         CCL = cc         LM = -lm
# LINUX   CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.4 CC = CC         CCL = CC         LM = -lsocket -lnsl

INCL = /usr/include/tine
LIBS = /usr/lib
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/servdef.h \
	${INCL}/errors.h \
	${INCL}/rpctypes.h \
	${INCL}/rpcdefs.h \
	${INCL}/almsrv.h 

CPP = g++ -c -g -Wno-deprecated -I${INCL}
CC = cc -c -g -I${INCL}
CCL = g++ -g
LM =

rpcserv: setbuildinfo arctools.o streqm.o lpceqm.o zipeqm.o arceqm.o eventlib.o nettools.o rpcserv.o ${LIBS}/libtine.a
	${CCL} -o rpcserv arctools.o streqm.o lpceqm.o zipeqm.o arceqm.o eventlib.o nettools.o rpcserv.o ${LIBS}/libtine.a ${LM}
	chmod a+s rpcserv

rpcserv.o: rpcserv.c app_version.h ${HDRS} 
	${CC} rpcserv.c

arctools.o: arctools.c ${HDRS}
	${CC} arctools.c

nettools.o: nettools.c ${HDRS}
	${CC} nettools.c 

streqm.o: streqm.c lpceqm.h arctools.h ${HDRS}
	${CC} streqm.c 

lpceqm.o: lpceqm.c lpceqm.h ${HDRS}
	${CC} lpceqm.c 

zipeqm.o: zipeqm.c ${HDRS}
	${CC} zipeqm.c 

arceqm.o: arceqm.cpp arceqm.h arctypes.h ${HDRS}
	${CPP} arceqm.cpp

eventlib.o: eventlib.cpp ${HDRS}
	${CPP} eventlib.cpp

setbuildinfo:
	./set-build-time

clean:
	rm *.o
