#ifndef ccerr
#define ccerr(i) { cc = i; goto err; }
#endif

#ifndef ulong
# define ulong UINT32
#endif

#define MAXARCHIVES 100
#define MAXFILES   500
#define MAXEQP    500
#define MAXPROP  1000
#define MAXSESSION 500

void filerinit(void);
void filertask(void);
int filer(char *devName,char *devProperty,DTYPE *dout,DTYPE *din,short access);
void fswap(NAME8 *fbuf,int i, int j);
void fileSort(NAME8 *fbuf,int start,int num);
void freeSession(int id);
void dozipTask(void);

typedef struct
{
  UINT32 sessionID;
  UINT32 event;
  char ext[4];
  char eqpName[16];
  char devName[16];
  char devProperty[32];
  UINT16 dSize;
  UINT16 dFormat;
} APCBLK;

typedef struct
{
  char ext[16];
  char nam[16];
  char src[80];
  char dst[80];
} ARCHRECORD;

typedef struct LPCtag
{
  char   prp[32];
  char   dev[16];
  UINT16 eqn,
         siz,
         fmt;
  UINT16 reserved;
  float  scale,
         shift;
  UINT32 dataPos;          /* location in file */
  struct LPCtag	*Next;
} LPCstruct;

typedef struct
{
  char name[16];        /* equipment function name (export name) */
  int  id;              /* session ID */
  LPCstruct *lpc;       /* pointer to a chain */
} EQP;

typedef struct
{
  time_t active,        /* last session request time */
         est;           /* session established */
  int count;
  int numEQP;           /* number of EQPs represented */
  int hFile;
  char fullName[80];
  char ext[4];
} SESSION;

typedef struct LHStag
{
   char devProperty[32];
   char devServer[16];
   float samplingrate; /* Abtastfrequenz                             */
   UINT16 format;
   UINT16 reserved;
   UINT32 arraySize;
   UINT32 lowcount;    /* kleinster Mewert in digits                */
   UINT32 highcount;   /* grter Mewert in digits                  */
   char egu[16];       /* physikalische Einheit                      */
   float egulow;       /* kleinster Mewert in physikalischer Einheit*/
   float eguhigh;      /* grter Mewert in physikalischer Einheit  */
   struct LHStag *next;
} LHS;   /* Local Header Structure  */

#define SRCVAL(d,n,fmt) (\
   fmt == CF_SHORT  ? (double) ((short *)d)[n] :\
   fmt == CF_LONG   ? (double) ((long *)d)[n] :\
   fmt == CF_LNGINT ? (double) ((LNGINT *)d)[n].lval :\
   fmt == CF_FLOAT  ? (double) ((float *)d)[n] :\
   fmt == CF_FLTINT ? (double) ((FLTINT *)d)[n].fval :\
   fmt == CF_DOUBLE ? (double) ((double *)d)[n] :\
   fmt == CF_DBLINT ? (double) ((DBLINT *)d)[n].dval :\
   fmt == CF_BYTE   ? (double) ((BYTE *)d)[n] :\
   fmt == CF_TEXT   ? (double) ((char *)d)[n] : (double)0\
)

#define srcptr(fmt) (\
  fmt == CF_SHORT ? (BYTE *)&sdat :\
  fmt == CF_LONG  ? (BYTE *)&ldat :\
  fmt == CF_FLOAT ? (BYTE *)&fdat :\
  fmt == CF_DOUBLE ? (BYTE *)&ddat: NULL\
)

#define ARCH_BUF_SIZE 0x20000

extern BYTE archiveBuffer[ARCH_BUF_SIZE];
extern ARCHRECORD ArchRecord[MAXARCHIVES];
extern void *LPCdata;
extern EQP EQPlist[MAXEQP];
extern SESSION session[MAXSESSION];
extern int numEQP;
extern int archDebug;

extern int (*filterArchiveData)(char *prp,char *nam,BYTE *buf,int fmt,UINT32 len,int EqNo);
int GetLocalSessionID(ulong eventNumber,char *ext);
int reformatArchiveData(void *dst,short dstFmt,void *src,short srcFmt,int size,float scale,float shift);
int reformatArchiveDataEx(void *dst,short dstFmt,void *src,short srcFmt,int index,int size,float scale,float shift);

