#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <dirent.h>
#include "rpctypes.h"
#include "arctools.h"
#include "errors.h"

typedef struct
{
  char ext[4];
  char src[80];
  char dst[80];
} ARCHRECORD;

int numZip = 0;
int ZIPdbg = 1;
extern ARCHRECORD ArchRecord[];
extern int numArchiveTypes;
extern int narb;
extern ARB *arb;

#ifndef ZIPDATAFILE
#  define ZIPDATAFILE "ziplist.csv"
#endif

int getZipContract(void)
{
  FILE *zfp;
  int i;
  char cbuff[512];

  if ((zfp=fopen(ZIPDATAFILE,"rt")) == NULL)
  {
    printf("could not open ZIP contract file!\n>");
    return 0;
  }

  fscanf(zfp,"%[^\n]%*c",(char *)cbuff);                /* // one line of header*/

  for (i=0; fscanf(zfp,"%[^,]%*c",ArchRecord[i].ext) != EOF; i++)
  {
    if (fscanf(zfp,"%[^,]%*c",ArchRecord[i].src) == EOF)
      return i-1;
    if (strlen(ArchRecord[i].src) > 79)
    {
      printf("Zip source path too long : %s\n>",ArchRecord[i].src);
    }

    if (fscanf(zfp,"%[^\n]%*c",ArchRecord[i].dst) == EOF)
      return i-1;

    if (strlen(ArchRecord[i].dst) > 79)
    {
      printf("Zip destination path too long : %s\n>",ArchRecord[i].dst);
    }
  }

  fclose(zfp);
  return i;
}

void dozipTask(void)
{
  char dirname[64],dstname[64],fext[5],*c;
  DIR *dp;
  struct dirent *dirp;
  int i;
  for (i=0; i<narb; i++) 
  {
    if ((dp=opendir(arb[i].src)) == NULL) continue;
    while ((dirp=readdir(dp)) != NULL)
    {
      sprintf(fext,".%s",arb[i].ext);
      if (!strstr(dirp->d_name,fext)) continue;
      if (arb[i].fp != NULL) continue; // still archiving
      strcpy(dstname,arb[i].dst);
      if ((c=strrchr(dirp->d_name,'/')) == NULL) c = dirp->d_name;
      sprintf(&dstname[strlen(dstname)],"/%s",c);
      if (rename(dirp->d_name,dstname)) perror("rename");
      if (ZIPdbg) printf("relocate %s to %s\n>",dirp->d_name,dstname);
    }
    closedir(dp);
  }
 
 return;
}
#pragma argsused
int D_zipeqm(double *Value, int RWFlag, int EqNo, char *Property)
{
  int i;

  if (!strcmp(Property,"ZIPLIST"))
  {
    printf("Currently registerd ZIP contracts :\n>");
	  for (i=0; i<numZip; i++)
	  {
      printf("\t%s.%s to %s.ZIP\n",ArchRecord[i].src,ArchRecord[i].ext,ArchRecord[i].dst);
		}
    return 0;
  }
  if (!strcmp(Property,"ZIPDBG"))
  {
		switch (RWFlag)
		{
			case -1: ZIPdbg= (int)Value[0];
			case  1: Value[0] = ZIPdbg;
							 return 0;
			default: return illegal_read_write;
		}
  }
  return illegal_property;
}
