/*
 * timeqm.c    REVISION HISTORY:
 * Generated by SRVWIZARD on Tue Mar 11 13:42:56 2003
*/

#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "errors.h"
#include "rpctypes.h"
#include "swaplib.h"
#include "almsrv.h"
#include "toolkit.h"
#include "timeqm.h"

double g_systime;

void cbSendSystime(int id, int cc)
{
  return;
}

void timeqm_bkg(void)
{
  int i;
  DTYPE din;

  din.dArrayLength = 1;
  din.dFormat = CF_DOUBLE;
  din.data.dptr = &g_systime;

  /* Clear alarms at start of IO task (see if they come back)    */
  ClearAlarm(TIMEQM_TAG,-1);

  /* TODO: replace SimulateData() with your own data acquisition       */
  /*       and manipulation routines                                   */
  g_systime = makeDataTimeStamp();
  sendNetGlobal("SYSTIME",&din,cbSendSystime,0,0,0);

  /* make use of SetAlarm() as needed :

  SetAlarm(TIMEQM_TAG,devNr,almCode,almFlag);

  */
}

/* Alternative to 'exports.csv': You can call 'RegisterTimeqmProperties()'   */
/*   -> This might be preferable in cases where the server does not have a   */
/*   -> file system.  You should also call RegisterServerName() in lieu of   */
/*   -> the 'fecid.csv' file.                                                */

int RegisterTimeqmProperties(void)
{
  int cc = 0;

  if ((cc=RegisterPropertyEx(TIMEQM_TAG,"SYSTIME",PRP_SYSTIME_SIZE,CF_DOUBLE,CA_READ,"[1e+10:1e+11 sec]System Time",PRP_SYSTIME)) < 0) goto err;
err:
  if (cc)
  {
    printf("Can't register property : %s\n>",erlst[-cc]);
  }
  return cc;
}

void timeqm_ini(void)
{
  char devnam[16];
  int i;
  DTYPE din;

  din.dArrayLength = 1;
  din.dFormat = CF_DOUBLE;
  din.data.dptr = &g_systime;
  sendNetGlobal("SYSTIME",&din,cbSendSystime,0,0,0);

  /* TODO: register any device names here */
  /*       below is only an example ...   */
  for (i=0; i<1; i++)
  {
    sprintf(devnam,"device_%d",i);
    RegisterDeviceName(TIMEQM_TAG,devnam,i);
  }

  /* TODO: register any global receive routines as in this example  */
  /*

  glbID = recvNetGlobal("HPMAGEN",&dout,rcvGlobal);

  */

  /* TODO: start any links you might need as in this example  */
  /*

  lnkID = AttachLinkEx("/HERA/BPM/WL197X","POSITIONS.X",&dout,&din,CA_READ,1000,showlink,CM_POLL,myid);

  */
}

void timeqm_exi(void)
{
  /* TODO: put your shutdown routines here */
}

int timeqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int devnr,prpid,i,cc;
  double l_systime;

  /* TODO: If READ properties take input data, include code to examine the contents of din. */
  /*       If different actions need to be taken at the start or end of a link, examine the */
  /*       'access' parameter against CA_FIRST or CA_LAST.                                  */
  /*       If allow format overloading (you return different data according to the request  */
  /*       format), then replace calls to putDataFromShort() etc with the desired code.     */

  prpid = GetPropertyId(TIMEQM_TAG,devProperty);

  switch (prpid)
  {
    case PRP_SYSTIME:
        if (access&CA_WRITE) return illegal_read_write;
        if (dout->dArrayLength > 0)
        {
          if (dout->dArrayLength > PRP_SYSTIME_SIZE) return dimension_error;
          if ((cc=putValuesFromDouble(dout,&g_systime,PRP_SYSTIME_SIZE)) != 0) return cc;
        }
        return 0;
    default:
        return illegal_property;
  }
}
